Index: src/pl/plpgsql/src/gram.y
===================================================================
RCS file: /var/lib/cvs/pgsql/src/pl/plpgsql/src/gram.y,v
retrieving revision 1.64
diff -c -r1.64 gram.y
*** src/pl/plpgsql/src/gram.y	25 Oct 2004 06:27:21 -0000	1.64
--- src/pl/plpgsql/src/gram.y	7 Feb 2005 05:10:00 -0000
***************
*** 50,55 ****
--- 50,57 ----
  static	PLpgSQL_stmt	*make_select_stmt(void);
  static	PLpgSQL_stmt	*make_fetch_stmt(void);
  static	void check_assignable(PLpgSQL_datum *datum);
+ static PLpgSQL_row		*read_into_scalar_list(const char *initial_name,
+ 											   PLpgSQL_datum *initial_datum);
  
  %}
  
***************
*** 63,80 ****
  		}						varname;
  		struct
  		{
- 			int  nalloc;
- 			int  nused;
- 			int	 *nums;
- 		}						intlist;
- 		struct
- 		{
- 			int  nalloc;
- 			int  nused;
- 			PLpgSQL_diag_item *dtitems;
- 		}						dtlist;
- 		struct
- 		{
  			char *name;
  			int  lineno;
  			PLpgSQL_rec	*rec;
--- 65,70 ----
***************
*** 86,91 ****
--- 76,82 ----
  			int  n_initvars;
  			int  *initvarnos;
  		}						declhdr;
+ 		List					*list;
  		PLpgSQL_type			*dtype;
  		PLpgSQL_datum			*scalar;	/* a VAR, RECFIELD, or TRIGARG */
  		PLpgSQL_variable		*variable;	/* a VAR, REC, or ROW */
***************
*** 94,105 ****
  		PLpgSQL_rec				*rec;
  		PLpgSQL_expr			*expr;
  		PLpgSQL_stmt			*stmt;
- 		PLpgSQL_stmts			*stmts;
  		PLpgSQL_stmt_block		*program;
  		PLpgSQL_condition		*condition;
  		PLpgSQL_exception		*exception;
- 		PLpgSQL_exceptions		*exceptions;
  		PLpgSQL_nsitem			*nsitem;
  }
  
  %type <declhdr> decl_sect
--- 85,95 ----
  		PLpgSQL_rec				*rec;
  		PLpgSQL_expr			*expr;
  		PLpgSQL_stmt			*stmt;
  		PLpgSQL_stmt_block		*program;
  		PLpgSQL_condition		*condition;
  		PLpgSQL_exception		*exception;
  		PLpgSQL_nsitem			*nsitem;
+ 		PLpgSQL_diag_item		*diagitem;
  }
  
  %type <declhdr> decl_sect
***************
*** 108,114 ****
  %type <ival>	decl_const decl_notnull
  %type <expr>	decl_defval decl_cursor_query
  %type <dtype>	decl_datatype
! %type <row>		decl_cursor_args decl_cursor_arglist
  %type <nsitem>	decl_aliasitem
  %type <str>		decl_stmts decl_stmt
  
--- 98,105 ----
  %type <ival>	decl_const decl_notnull
  %type <expr>	decl_defval decl_cursor_query
  %type <dtype>	decl_datatype
! %type <row>		decl_cursor_args
! %type <list>	decl_cursor_arglist
  %type <nsitem>	decl_aliasitem
  %type <str>		decl_stmts decl_stmt
  
***************
*** 126,132 ****
  %type <str>		opt_exitlabel
  %type <str>		execsql_start
  
! %type <stmts>	proc_sect proc_stmts stmt_else loop_body
  %type <stmt>	proc_stmt pl_block
  %type <stmt>	stmt_assign stmt_if stmt_loop stmt_while stmt_exit
  %type <stmt>	stmt_return stmt_return_next stmt_raise stmt_execsql
--- 117,123 ----
  %type <str>		opt_exitlabel
  %type <str>		execsql_start
  
! %type <list>	proc_sect proc_stmts stmt_else loop_body
  %type <stmt>	proc_stmt pl_block
  %type <stmt>	stmt_assign stmt_if stmt_loop stmt_while stmt_exit
  %type <stmt>	stmt_return stmt_return_next stmt_raise stmt_execsql
***************
*** 134,149 ****
  %type <stmt>	stmt_dynexecute stmt_getdiag
  %type <stmt>	stmt_open stmt_fetch stmt_close stmt_null
  
! %type <exceptions>	exception_sect proc_exceptions
  %type <exception>	proc_exception
  %type <condition>	proc_conditions
  
! %type <intlist>	raise_params
  %type <ival>	raise_level raise_param
  %type <str>		raise_msg
  
! %type <dtlist>	getdiag_list
! %type <ival>	getdiag_item getdiag_target
  
  %type <ival>	lno
  
--- 125,141 ----
  %type <stmt>	stmt_dynexecute stmt_getdiag
  %type <stmt>	stmt_open stmt_fetch stmt_close stmt_null
  
! %type <list>	exception_sect proc_exceptions
  %type <exception>	proc_exception
  %type <condition>	proc_conditions
  
! %type <list>	raise_params
  %type <ival>	raise_level raise_param
  %type <str>		raise_msg
  
! %type <list>	getdiag_list
! %type <diagitem> getdiag_list_item
! %type <ival>	getdiag_kind getdiag_target
  
  %type <ival>	lno
  
***************
*** 240,246 ****
  
  comp_option		: O_OPTION O_DUMP
  					{
! 						plpgsql_DumpExecTree = 1;
  					}
  				;
  
--- 232,238 ----
  
  comp_option		: O_OPTION O_DUMP
  					{
! 						plpgsql_DumpExecTree = true;
  					}
  				;
  
***************
*** 252,259 ****
  					{
  						PLpgSQL_stmt_block *new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_block));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_block));
  
  						new->cmd_type	= PLPGSQL_STMT_BLOCK;
  						new->lineno		= $3;
--- 244,250 ----
  					{
  						PLpgSQL_stmt_block *new;
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_block));
  
  						new->cmd_type	= PLPGSQL_STMT_BLOCK;
  						new->lineno		= $3;
***************
*** 379,386 ****
  																		  -1),
  												   true);
  
! 						curname_def = malloc(sizeof(PLpgSQL_expr));
! 						memset(curname_def, 0, sizeof(PLpgSQL_expr));
  
  						curname_def->dtype = PLPGSQL_DTYPE_EXPR;
  						strcpy(buf, "SELECT '");
--- 370,376 ----
  																		  -1),
  												   true);
  
! 						curname_def = palloc0(sizeof(PLpgSQL_expr));
  
  						curname_def->dtype = PLPGSQL_DTYPE_EXPR;
  						strcpy(buf, "SELECT '");
***************
*** 393,399 ****
  							*cp2++ = *cp1++;
  						}
  						strcpy(cp2, "'::refcursor");
! 						curname_def->query = strdup(buf);
  						new->default_val = curname_def;
  
  						new->cursor_explicit_expr = $6;
--- 383,389 ----
  							*cp2++ = *cp1++;
  						}
  						strcpy(cp2, "'::refcursor");
! 						curname_def->query = pstrdup(buf);
  						new->default_val = curname_def;
  
  						new->cursor_explicit_expr = $6;
***************
*** 422,483 ****
  					}
  				| '(' decl_cursor_arglist ')'
  					{
- 						/* Copy the temp arrays to malloc'd storage */
- 						int nfields = $2->nfields;
- 						char **ftmp;
- 						int *vtmp;
- 
- 						ftmp = malloc(nfields * sizeof(char *));
- 						vtmp = malloc(nfields * sizeof(int));
- 						memcpy(ftmp, $2->fieldnames, nfields * sizeof(char *));
- 						memcpy(vtmp, $2->varnos, nfields * sizeof(int));
- 
- 						pfree($2->fieldnames);
- 						pfree($2->varnos);
- 
- 						$2->fieldnames = ftmp;
- 						$2->varnos = vtmp;
- 
- 						plpgsql_adddatum((PLpgSQL_datum *)$2);
- 
- 						$$ = $2;
- 					}
- 				;
- 
- decl_cursor_arglist : decl_cursor_arg
- 					{
  						PLpgSQL_row *new;
  
! 						new = malloc(sizeof(PLpgSQL_row));
! 						memset(new, 0, sizeof(PLpgSQL_row));
! 
  						new->dtype = PLPGSQL_DTYPE_ROW;
- 						new->refname = strdup("*internal*");
  						new->lineno = plpgsql_scanner_lineno();
  						new->rowtupdesc = NULL;
! 						/*
! 						 * We make temporary fieldnames/varnos arrays that
! 						 * are much bigger than necessary.  We will resize
! 						 * them to just the needed size in the
! 						 * decl_cursor_args production.
! 						 */
! 						new->fieldnames = palloc(1024 * sizeof(char *));
! 						new->varnos = palloc(1024 * sizeof(int));
! 						new->nfields = 1;
  
! 						new->fieldnames[0] = $1->refname;
! 						new->varnos[0] = $1->dno;
  
  						$$ = new;
  					}
! 				| decl_cursor_arglist ',' decl_cursor_arg
! 					{
! 						int i = $1->nfields++;
! 
! 						$1->fieldnames[i] = $3->refname;
! 						$1->varnos[i] = $3->dno;
  
! 						$$ = $1;
  					}
  				;
  
--- 412,451 ----
  					}
  				| '(' decl_cursor_arglist ')'
  					{
  						PLpgSQL_row *new;
+ 						int i;
+ 						ListCell *l;
  
! 						new = palloc0(sizeof(PLpgSQL_row));
  						new->dtype = PLPGSQL_DTYPE_ROW;
  						new->lineno = plpgsql_scanner_lineno();
  						new->rowtupdesc = NULL;
! 						new->nfields = list_length($2);
! 						new->fieldnames = palloc(new->nfields * sizeof(char *));
! 						new->varnos = palloc(new->nfields * sizeof(int));
  
! 						i = 0;
! 						foreach (l, $2)
! 						{
! 							PLpgSQL_variable *arg = (PLpgSQL_variable *) lfirst(l);
! 							new->fieldnames[i] = arg->refname;
! 							new->varnos[i] = arg->dno;
! 							i++;
! 						}
! 						list_free($2);
  
+ 						plpgsql_adddatum((PLpgSQL_datum *) new);
  						$$ = new;
  					}
! 				;
  
! decl_cursor_arglist : decl_cursor_arglist decl_cursor_arg
! 					{
! 						$$ = lappend($1, $2);
! 					}
! 				| decl_cursor_arg
! 					{
! 						$$ = list_make1($1);
  					}
  				;
  
***************
*** 524,531 ****
  						char	*name;
  
  						plpgsql_convert_ident(yytext, &name, 1);
! 						/* name should be malloc'd for use as varname */
! 						$$.name = strdup(name);
  						$$.lineno  = plpgsql_scanner_lineno();
  						pfree(name);
  					}
--- 492,498 ----
  						char	*name;
  
  						plpgsql_convert_ident(yytext, &name, 1);
! 						$$.name = pstrdup(name);
  						$$.lineno  = plpgsql_scanner_lineno();
  						pfree(name);
  					}
***************
*** 580,590 ****
  
  proc_sect		:
  					{
! 							PLpgSQL_stmts	*new;
! 
! 							new = malloc(sizeof(PLpgSQL_stmts));
! 							memset(new, 0, sizeof(PLpgSQL_stmts));
! 							$$ = new;
  					}
  				| proc_stmts
  					{ $$ = $1; }
--- 547,553 ----
  
  proc_sect		:
  					{
! 						$$ = NIL;
  					}
  				| proc_stmts
  					{ $$ = $1; }
***************
*** 592,622 ****
  
  proc_stmts		: proc_stmts proc_stmt
  						{
! 							if ($2 != NULL)
! 							{
! 								if ($1->stmts_used == $1->stmts_alloc)
! 								{
! 									$1->stmts_alloc *= 2;
! 									$1->stmts = realloc($1->stmts, sizeof(PLpgSQL_stmt *) * $1->stmts_alloc);
! 								}
! 								$1->stmts[$1->stmts_used++] = $2;
! 							}
! 							$$ = $1;
  						}
  				| proc_stmt
  						{
! 							PLpgSQL_stmts	*new;
! 
! 							new = malloc(sizeof(PLpgSQL_stmts));
! 							memset(new, 0, sizeof(PLpgSQL_stmts));
! 
! 							new->stmts_alloc = 32;
! 							new->stmts = malloc(sizeof(PLpgSQL_stmt *) * new->stmts_alloc);
! 
! 							if ($1 != NULL)
! 								new->stmts[new->stmts_used++] = $1;
! 
! 							$$ = new;
  						}
  				;
  
--- 555,571 ----
  
  proc_stmts		: proc_stmts proc_stmt
  						{
! 							if ($2 == NULL)
! 								$$ = $1;
! 							else
! 								$$ = lappend($1, $2);
  						}
  				| proc_stmt
  						{
! 							if ($1 == NULL)
! 								$$ = NULL;
! 							else
! 								$$ = list_make1($1);
  						}
  				;
  
***************
*** 664,672 ****
  					{
  						PLpgSQL_stmt_perform *new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_perform));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_perform));
! 
  						new->cmd_type = PLPGSQL_STMT_PERFORM;
  						new->lineno   = $2;
  						new->expr  = $3;
--- 613,619 ----
  					{
  						PLpgSQL_stmt_perform *new;
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_perform));
  						new->cmd_type = PLPGSQL_STMT_PERFORM;
  						new->lineno   = $2;
  						new->expr  = $3;
***************
*** 679,687 ****
  					{
  						PLpgSQL_stmt_assign *new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_assign));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_assign));
! 
  						new->cmd_type = PLPGSQL_STMT_ASSIGN;
  						new->lineno   = $2;
  						new->varno = $1;
--- 626,632 ----
  					{
  						PLpgSQL_stmt_assign *new;
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_assign));
  						new->cmd_type = PLPGSQL_STMT_ASSIGN;
  						new->lineno   = $2;
  						new->varno = $1;
***************
*** 695,739 ****
  					{
  						PLpgSQL_stmt_getdiag	 *new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_getdiag));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_getdiag));
! 
  						new->cmd_type = PLPGSQL_STMT_GETDIAG;
  						new->lineno   = $3;
! 						new->ndtitems = $4.nused;
! 						new->dtitems  = malloc(sizeof(PLpgSQL_diag_item) * $4.nused);
! 						memcpy(new->dtitems, $4.dtitems, sizeof(PLpgSQL_diag_item) * $4.nused);
  
  						$$ = (PLpgSQL_stmt *)new;
  					}
  				;
  
! getdiag_list : getdiag_list ',' getdiag_target K_ASSIGN getdiag_item
  					{
! 						if ($1.nused == $1.nalloc)
! 						{
! 							$1.nalloc *= 2;
! 							$1.dtitems = repalloc($1.dtitems, sizeof(PLpgSQL_diag_item) * $1.nalloc);
! 						}
! 						$1.dtitems[$1.nused].target = $3;
! 						$1.dtitems[$1.nused].item   = $5;
! 						$1.nused++;
! 
! 						$$.nalloc = $1.nalloc;
! 						$$.nused  = $1.nused;
! 						$$.dtitems = $1.dtitems;
  					}
! 				| getdiag_target K_ASSIGN getdiag_item
  					{
! 						$$.nalloc = 1;
! 						$$.nused  = 1;
! 						$$.dtitems = palloc(sizeof(PLpgSQL_diag_item) * $$.nalloc);
! 						$$.dtitems[0].target = $1;
! 						$$.dtitems[0].item   = $3;
  					}
  				;
  
! getdiag_item : K_ROW_COUNT
  					{
  						$$ = PLPGSQL_GETDIAG_ROW_COUNT;
  					}
--- 640,677 ----
  					{
  						PLpgSQL_stmt_getdiag	 *new;
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_getdiag));
  						new->cmd_type = PLPGSQL_STMT_GETDIAG;
  						new->lineno   = $3;
! 						new->diag_items  = $4;
  
  						$$ = (PLpgSQL_stmt *)new;
  					}
  				;
  
! getdiag_list : getdiag_list ',' getdiag_list_item
  					{
! 						$$ = lappend($1, $3);
! 					}
! 				| getdiag_list_item
! 					{
! 						$$ = list_make1($1);
  					}
! 				;
! 
! getdiag_list_item : getdiag_target K_ASSIGN getdiag_kind
  					{
! 						PLpgSQL_diag_item *new;
! 
! 						new = palloc(sizeof(PLpgSQL_diag_item));
! 						new->target = $1;
! 						new->kind = $3;
! 
! 						$$ = new;
  					}
  				;
  
! getdiag_kind : K_ROW_COUNT
  					{
  						$$ = PLPGSQL_GETDIAG_ROW_COUNT;
  					}
***************
*** 770,778 ****
  					{
  						PLpgSQL_arrayelem	*new;
  
! 						new = malloc(sizeof(PLpgSQL_arrayelem));
! 						memset(new, 0, sizeof(PLpgSQL_arrayelem));
! 
  						new->dtype		= PLPGSQL_DTYPE_ARRAYELEM;
  						new->subscript	= $3;
  						new->arrayparentno = $1;
--- 708,714 ----
  					{
  						PLpgSQL_arrayelem	*new;
  
! 						new = palloc0(sizeof(PLpgSQL_arrayelem));
  						new->dtype		= PLPGSQL_DTYPE_ARRAYELEM;
  						new->subscript	= $3;
  						new->arrayparentno = $1;
***************
*** 787,795 ****
  					{
  						PLpgSQL_stmt_if *new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_if));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_if));
! 
  						new->cmd_type	= PLPGSQL_STMT_IF;
  						new->lineno		= $2;
  						new->cond		= $3;
--- 723,729 ----
  					{
  						PLpgSQL_stmt_if *new;
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_if));
  						new->cmd_type	= PLPGSQL_STMT_IF;
  						new->lineno		= $2;
  						new->cond		= $3;
***************
*** 802,853 ****
  
  stmt_else		:
  					{
! 							PLpgSQL_stmts	*new;
! 
! 							new = malloc(sizeof(PLpgSQL_stmts));
! 							memset(new, 0, sizeof(PLpgSQL_stmts));
! 							$$ = new;
  					}
  				| K_ELSIF lno expr_until_then proc_sect stmt_else
  					{
! 					  /*
! 					   * Translate the structure:	   into:
! 					   *
! 					   * IF c1 THEN					   IF c1 THEN		 
! 					   *	 ...						   ...				 
! 					   * ELSIF c2 THEN				   ELSE 
! 					   *								   IF c2 THEN	
! 					   *	 ...							   ...				 
! 					   * ELSE							   ELSE				 
! 					   *	 ...							   ...				 
! 					   * END IF							   END IF			 
! 					   *							   END IF
! 					   * 
! 					   */
! 
! 						PLpgSQL_stmts	*new;
  						PLpgSQL_stmt_if *new_if;
  
  						/* first create a new if-statement */
! 						new_if = malloc(sizeof(PLpgSQL_stmt_if));
! 						memset(new_if, 0, sizeof(PLpgSQL_stmt_if));
! 
  						new_if->cmd_type	= PLPGSQL_STMT_IF;
  						new_if->lineno		= $2;
  						new_if->cond		= $3;
  						new_if->true_body	= $4;
  						new_if->false_body	= $5;
- 						
- 						/* this is a 'container' for the if-statement */
- 						new = malloc(sizeof(PLpgSQL_stmts));
- 						memset(new, 0, sizeof(PLpgSQL_stmts));
- 						
- 						new->stmts_alloc = 64;
- 						new->stmts_used	 = 1;
- 						new->stmts = malloc(sizeof(PLpgSQL_stmt *) * new->stmts_alloc);
- 						new->stmts[0] = (PLpgSQL_stmt *) new_if;
  
! 						$$ = new;
  						
  					}
  
--- 736,770 ----
  
  stmt_else		:
  					{
! 						$$ = NIL;
  					}
  				| K_ELSIF lno expr_until_then proc_sect stmt_else
  					{
! 						/*
! 						 * Translate the structure:	   into:
! 						 *
! 						 * IF c1 THEN				   IF c1 THEN
! 						 *	 ...						   ...
! 						 * ELSIF c2 THEN			   ELSE
! 						 *								   IF c2 THEN
! 						 *	 ...							   ...
! 						 * ELSE							   ELSE
! 						 *	 ...							   ...
! 						 * END IF						   END IF			 
! 						 *							   END IF
! 						 */
  						PLpgSQL_stmt_if *new_if;
  
  						/* first create a new if-statement */
! 						new_if = palloc0(sizeof(PLpgSQL_stmt_if));
  						new_if->cmd_type	= PLPGSQL_STMT_IF;
  						new_if->lineno		= $2;
  						new_if->cond		= $3;
  						new_if->true_body	= $4;
  						new_if->false_body	= $5;
  
! 						/* wrap the if-statement in a "container" list */
! 						$$ = list_make1(new_if);
  						
  					}
  
***************
*** 861,869 ****
  					{
  						PLpgSQL_stmt_loop *new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_loop));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_loop));
! 
  						new->cmd_type = PLPGSQL_STMT_LOOP;
  						new->lineno   = $3;
  						new->label	  = $1;
--- 778,784 ----
  					{
  						PLpgSQL_stmt_loop *new;
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_loop));
  						new->cmd_type = PLPGSQL_STMT_LOOP;
  						new->lineno   = $3;
  						new->label	  = $1;
***************
*** 879,887 ****
  					{
  						PLpgSQL_stmt_while *new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_while));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_while));
! 
  						new->cmd_type = PLPGSQL_STMT_WHILE;
  						new->lineno   = $3;
  						new->label	  = $1;
--- 794,800 ----
  					{
  						PLpgSQL_stmt_while *new;
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_while));
  						new->cmd_type = PLPGSQL_STMT_WHILE;
  						new->lineno   = $3;
  						new->label	  = $1;
***************
*** 974,982 ****
  								yyerror("cannot specify EXECUTE in integer for-loop");
  							}
  
- 							/* name should be malloc'd for use as varname */
  							fvar = (PLpgSQL_var *)
! 								plpgsql_build_variable(strdup($2.name),
  													   $2.lineno,
  													   plpgsql_build_datatype(INT4OID,
  																			  -1),
--- 887,894 ----
  								yyerror("cannot specify EXECUTE in integer for-loop");
  							}
  
  							fvar = (PLpgSQL_var *)
! 								plpgsql_build_variable($2.name,
  													   $2.lineno,
  													   plpgsql_build_datatype(INT4OID,
  																			  -1),
***************
*** 985,993 ****
  							/* put the for-variable into the local block */
  							plpgsql_add_initdatums(NULL);
  
! 							new = malloc(sizeof(PLpgSQL_stmt_fori));
! 							memset(new, 0, sizeof(PLpgSQL_stmt_fori));
! 
  							new->cmd_type = PLPGSQL_STMT_FORI;
  							new->lineno   = $1;
  							new->var	  = fvar;
--- 897,903 ----
  							/* put the for-variable into the local block */
  							plpgsql_add_initdatums(NULL);
  
! 							new = palloc0(sizeof(PLpgSQL_stmt_fori));
  							new->cmd_type = PLPGSQL_STMT_FORI;
  							new->lineno   = $1;
  							new->var	  = fvar;
***************
*** 1008,1016 ****
  								yyerror("cannot specify REVERSE in loop over rows");
  							}
  
! 							new = malloc(sizeof(PLpgSQL_stmt_dynfors));
! 							memset(new, 0, sizeof(PLpgSQL_stmt_dynfors));
! 
  							new->cmd_type = PLPGSQL_STMT_DYNFORS;
  							new->lineno   = $1;
  							if ($2.rec)
--- 918,924 ----
  								yyerror("cannot specify REVERSE in loop over rows");
  							}
  
! 							new = palloc0(sizeof(PLpgSQL_stmt_dynfors));
  							new->cmd_type = PLPGSQL_STMT_DYNFORS;
  							new->lineno   = $1;
  							if ($2.rec)
***************
*** 1038,1046 ****
  								yyerror("cannot specify REVERSE in loop over rows");
  							}
  
! 							new = malloc(sizeof(PLpgSQL_stmt_fors));
! 							memset(new, 0, sizeof(PLpgSQL_stmt_fors));
! 
  							new->cmd_type = PLPGSQL_STMT_FORS;
  							new->lineno   = $1;
  							if ($2.rec)
--- 946,952 ----
  								yyerror("cannot specify REVERSE in loop over rows");
  							}
  
! 							new = palloc0(sizeof(PLpgSQL_stmt_fors));
  							new->cmd_type = PLPGSQL_STMT_FORS;
  							new->lineno   = $1;
  							if ($2.rec)
***************
*** 1056,1063 ****
  							 * Must get rid of the "SELECT " we prepended
  							 * to expr1's text
  							 */
! 							newquery = strdup(expr1->query + 7);
! 							free(expr1->query);
  							expr1->query = newquery;
  
  							new->query = expr1;
--- 962,969 ----
  							 * Must get rid of the "SELECT " we prepended
  							 * to expr1's text
  							 */
! 							newquery = pstrdup(expr1->query + 7);
! 							pfree(expr1->query);
  							expr1->query = newquery;
  
  							new->query = expr1;
***************
*** 1120,1128 ****
  					{
  						PLpgSQL_stmt_exit *new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_exit));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_exit));
! 
  						new->cmd_type = PLPGSQL_STMT_EXIT;
  						new->lineno   = $2;
  						new->label	  = $3;
--- 1026,1032 ----
  					{
  						PLpgSQL_stmt_exit *new;
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_exit));
  						new->cmd_type = PLPGSQL_STMT_EXIT;
  						new->lineno   = $2;
  						new->label	  = $3;
***************
*** 1136,1143 ****
  					{
  						PLpgSQL_stmt_return *new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_return));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_return));
  						new->expr = NULL;
  						new->retrecno	= -1;
  						new->retrowno	= -1;
--- 1040,1046 ----
  					{
  						PLpgSQL_stmt_return *new;
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_return));
  						new->expr = NULL;
  						new->retrecno	= -1;
  						new->retrowno	= -1;
***************
*** 1189,1197 ****
  						if (!plpgsql_curr_compile->fn_retset)
  							yyerror("cannot use RETURN NEXT in a non-SETOF function");
  
! 						new = malloc(sizeof(PLpgSQL_stmt_return_next));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_return_next));
! 
  						new->cmd_type	= PLPGSQL_STMT_RETURN_NEXT;
  						new->lineno		= $2;
  
--- 1092,1098 ----
  						if (!plpgsql_curr_compile->fn_retset)
  							yyerror("cannot use RETURN NEXT in a non-SETOF function");
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_return_next));
  						new->cmd_type	= PLPGSQL_STMT_RETURN_NEXT;
  						new->lineno		= $2;
  
***************
*** 1220,1234 ****
  					{
  						PLpgSQL_stmt_raise		*new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_raise));
  
  						new->cmd_type	= PLPGSQL_STMT_RAISE;
  						new->lineno		= $2;
  						new->elog_level = $3;
  						new->message	= $4;
! 						new->nparams	= $5.nused;
! 						new->params		= malloc(sizeof(int) * $5.nused);
! 						memcpy(new->params, $5.nums, sizeof(int) * $5.nused);
  
  						$$ = (PLpgSQL_stmt *)new;
  					}
--- 1121,1133 ----
  					{
  						PLpgSQL_stmt_raise		*new;
  
! 						new = palloc(sizeof(PLpgSQL_stmt_raise));
  
  						new->cmd_type	= PLPGSQL_STMT_RAISE;
  						new->lineno		= $2;
  						new->elog_level = $3;
  						new->message	= $4;
! 						new->params		= $5;
  
  						$$ = (PLpgSQL_stmt *)new;
  					}
***************
*** 1236,1249 ****
  					{
  						PLpgSQL_stmt_raise		*new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_raise));
  
  						new->cmd_type	= PLPGSQL_STMT_RAISE;
  						new->lineno		= $2;
  						new->elog_level = $3;
  						new->message	= $4;
! 						new->nparams	= 0;
! 						new->params		= NULL;
  
  						$$ = (PLpgSQL_stmt *)new;
  					}
--- 1135,1147 ----
  					{
  						PLpgSQL_stmt_raise		*new;
  
! 						new = palloc(sizeof(PLpgSQL_stmt_raise));
  
  						new->cmd_type	= PLPGSQL_STMT_RAISE;
  						new->lineno		= $2;
  						new->elog_level = $3;
  						new->message	= $4;
! 						new->params		= NIL;
  
  						$$ = (PLpgSQL_stmt *)new;
  					}
***************
*** 1283,1305 ****
  
  raise_params	: raise_params raise_param
  					{
! 						if ($1.nused == $1.nalloc)
! 						{
! 							$1.nalloc *= 2;
! 							$1.nums = repalloc($1.nums, sizeof(int) * $1.nalloc);
! 						}
! 						$1.nums[$1.nused++] = $2;
! 
! 						$$.nalloc = $1.nalloc;
! 						$$.nused  = $1.nused;
! 						$$.nums   = $1.nums;
  					}
  				| raise_param
  					{
! 						$$.nalloc = 1;
! 						$$.nused  = 1;
! 						$$.nums   = palloc(sizeof(int) * $$.nalloc);
! 						$$.nums[0] = $1;
  					}
  				;
  
--- 1181,1191 ----
  
  raise_params	: raise_params raise_param
  					{
! 						$$ = lappend_int($1, $2);
  					}
  				| raise_param
  					{
! 						$$ = list_make1_int($1);
  					}
  				;
  
***************
*** 1317,1323 ****
  					{
  						PLpgSQL_stmt_execsql	*new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_execsql));
  						new->cmd_type = PLPGSQL_STMT_EXECSQL;
  						new->lineno   = $2;
  						new->sqlstmt  = read_sql_stmt($1);
--- 1203,1209 ----
  					{
  						PLpgSQL_stmt_execsql	*new;
  
! 						new = palloc(sizeof(PLpgSQL_stmt_execsql));
  						new->cmd_type = PLPGSQL_STMT_EXECSQL;
  						new->lineno   = $2;
  						new->sqlstmt  = read_sql_stmt($1);
***************
*** 1330,1336 ****
  						{
  							PLpgSQL_stmt_dynexecute *new;
  
! 							new = malloc(sizeof(PLpgSQL_stmt_dynexecute));
  							new->cmd_type = PLPGSQL_STMT_DYNEXECUTE;
  							new->lineno   = $2;
  							new->query	  = $3;
--- 1216,1222 ----
  						{
  							PLpgSQL_stmt_dynexecute *new;
  
! 							new = palloc(sizeof(PLpgSQL_stmt_dynexecute));
  							new->cmd_type = PLPGSQL_STMT_DYNEXECUTE;
  							new->lineno   = $2;
  							new->query	  = $3;
***************
*** 1344,1352 ****
  						PLpgSQL_stmt_open *new;
  						int				  tok;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_open));
! 						memset(new, 0, sizeof(PLpgSQL_stmt_open));
! 
  						new->cmd_type = PLPGSQL_STMT_OPEN;
  						new->lineno = $2;
  						new->curvar = $3->varno;
--- 1230,1236 ----
  						PLpgSQL_stmt_open *new;
  						int				  tok;
  
! 						new = palloc0(sizeof(PLpgSQL_stmt_open));
  						new->cmd_type = PLPGSQL_STMT_OPEN;
  						new->lineno = $2;
  						new->curvar = $3->varno;
***************
*** 1488,1494 ****
  					{
  						PLpgSQL_stmt_close *new;
  
! 						new = malloc(sizeof(PLpgSQL_stmt_close));
  						new->cmd_type = PLPGSQL_STMT_CLOSE;
  						new->lineno = $2;
  						new->curvar = $3;
--- 1372,1378 ----
  					{
  						PLpgSQL_stmt_close *new;
  
! 						new = palloc(sizeof(PLpgSQL_stmt_close));
  						new->cmd_type = PLPGSQL_STMT_CLOSE;
  						new->lineno = $2;
  						new->curvar = $3;
***************
*** 1539,1579 ****
  				;
  
  execsql_start	: T_WORD
! 					{ $$ = strdup(yytext); }
  				| T_ERROR
! 					{ $$ = strdup(yytext); }
  				;
  
  exception_sect	:
! 					{ $$ = NULL; }
  				| K_EXCEPTION proc_exceptions
  					{ $$ = $2; }
  				;
  
  proc_exceptions	: proc_exceptions proc_exception
  						{
! 								if ($1->exceptions_used == $1->exceptions_alloc)
! 								{
! 									$1->exceptions_alloc *= 2;
! 									$1->exceptions = realloc($1->exceptions, sizeof(PLpgSQL_exception *) * $1->exceptions_alloc);
! 								}
! 								$1->exceptions[$1->exceptions_used++] = $2;
! 
! 								$$ = $1;
  						}
  				| proc_exception
  						{
! 								PLpgSQL_exceptions	*new;
! 
! 								new = malloc(sizeof(PLpgSQL_exceptions));
! 								memset(new, 0, sizeof(PLpgSQL_exceptions));
! 
! 								new->exceptions_alloc = 16;
! 								new->exceptions_used  = 1;
! 								new->exceptions = malloc(sizeof(PLpgSQL_exception *) * new->exceptions_alloc);
! 								new->exceptions[0] = $1;
! 
! 								$$ = new;
  						}
  				;
  
--- 1423,1446 ----
  				;
  
  execsql_start	: T_WORD
! 					{ $$ = pstrdup(yytext); }
  				| T_ERROR
! 					{ $$ = pstrdup(yytext); }
  				;
  
  exception_sect	:
! 					{ $$ = NIL; }
  				| K_EXCEPTION proc_exceptions
  					{ $$ = $2; }
  				;
  
  proc_exceptions	: proc_exceptions proc_exception
  						{
! 							$$ = lappend($1, $2);
  						}
  				| proc_exception
  						{
! 							$$ = list_make1($1);
  						}
  				;
  
***************
*** 1581,1589 ****
  					{
  						PLpgSQL_exception *new;
  
! 						new = malloc(sizeof(PLpgSQL_exception));
! 						memset(new, 0, sizeof(PLpgSQL_exception));
! 
  						new->lineno     = $2;
  						new->conditions = $3;
  						new->action	    = $5;
--- 1448,1454 ----
  					{
  						PLpgSQL_exception *new;
  
! 						new = palloc0(sizeof(PLpgSQL_exception));
  						new->lineno     = $2;
  						new->conditions = $3;
  						new->action	    = $5;
***************
*** 1643,1650 ****
  						char	*name;
  
  						plpgsql_convert_ident(yytext, &name, 1);
! 						$$ = strdup(name);
! 						pfree(name);
  					}
  				| T_WORD
  					{
--- 1508,1514 ----
  						char	*name;
  
  						plpgsql_convert_ident(yytext, &name, 1);
! 						$$ = name;
  					}
  				| T_WORD
  					{
***************
*** 1664,1671 ****
  						char	*name;
  
  						plpgsql_convert_ident(yytext, &name, 1);
! 						$$ = strdup(name);
! 						pfree(name);
  					}
  				;
  
--- 1528,1534 ----
  						char	*name;
  
  						plpgsql_convert_ident(yytext, &name, 1);
! 						$$ = name;
  					}
  				;
  
***************
*** 1788,1801 ****
  				plpgsql_dstring_append(&ds, yytext);
  				break;
  		}
  	}
  
  	if (endtoken)
  		*endtoken = tok;
  
! 	expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * nparams - sizeof(int));
  	expr->dtype			= PLPGSQL_DTYPE_EXPR;
! 	expr->query			= strdup(plpgsql_dstring_get(&ds));
  	expr->plan			= NULL;
  	expr->nparams		= nparams;
  	while(nparams-- > 0)
--- 1651,1673 ----
  				plpgsql_dstring_append(&ds, yytext);
  				break;
  		}
+ 
+ 		/* Check for array overflow */
+ 		if (nparams >= 1024)
+ 		{
+ 			plpgsql_error_lineno = plpgsql_scanner_lineno();
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
+ 					 errmsg("too many variables specified in SQL statement")));
+ 		}
  	}
  
  	if (endtoken)
  		*endtoken = tok;
  
! 	expr = palloc(sizeof(PLpgSQL_expr) + sizeof(int) * nparams - sizeof(int));
  	expr->dtype			= PLPGSQL_DTYPE_EXPR;
! 	expr->query			= pstrdup(plpgsql_dstring_get(&ds));
  	expr->plan			= NULL;
  	expr->nparams		= nparams;
  	while(nparams-- > 0)
***************
*** 1870,1876 ****
  	return result;
  }
  
- 
  static PLpgSQL_stmt *
  make_select_stmt(void)
  {
--- 1742,1747 ----
***************
*** 1881,1898 ****
  	PLpgSQL_expr		*expr;
  	PLpgSQL_row			*row = NULL;
  	PLpgSQL_rec			*rec = NULL;
! 	int					tok = 0;
! 	int					have_nexttok = 0;
! 	int					have_into = 0;
  
  	plpgsql_dstring_init(&ds);
  	plpgsql_dstring_append(&ds, "SELECT ");
  
! 	while(1)
  	{
! 		if (!have_nexttok)
! 			tok = yylex();
! 		have_nexttok = 0;
  		if (tok == ';')
  			break;
  		if (tok == 0)
--- 1752,1767 ----
  	PLpgSQL_expr		*expr;
  	PLpgSQL_row			*row = NULL;
  	PLpgSQL_rec			*rec = NULL;
! 	int					tok;
! 	bool				have_into = false;
  
  	plpgsql_dstring_init(&ds);
  	plpgsql_dstring_append(&ds, "SELECT ");
  
! 	while (1)
  	{
! 		tok = yylex();
! 
  		if (tok == ';')
  			break;
  		if (tok == 0)
***************
*** 1916,1984 ****
  			{
  				case T_ROW:
  					row = yylval.row;
! 					have_into = 1;
  					break;
  
  				case T_RECORD:
  					rec = yylval.rec;
! 					have_into = 1;
  					break;
  
  				case T_SCALAR:
! 				{
! 					int				nfields = 1;
! 					char			*fieldnames[1024];
! 					int				varnos[1024];
! 
! 					check_assignable(yylval.scalar);
! 					fieldnames[0] = strdup(yytext);
! 					varnos[0]	  = yylval.scalar->dno;
! 
! 					while ((tok = yylex()) == ',')
! 					{
! 						tok = yylex();
! 						switch(tok)
! 						{
! 							case T_SCALAR:
! 								check_assignable(yylval.scalar);
! 								fieldnames[nfields] = strdup(yytext);
! 								varnos[nfields++]	= yylval.scalar->dno;
! 								break;
! 
! 							default:
! 								plpgsql_error_lineno = plpgsql_scanner_lineno();
! 								ereport(ERROR,
! 										(errcode(ERRCODE_SYNTAX_ERROR),
! 										 errmsg("\"%s\" is not a variable",
! 												yytext)));
! 						}
! 					}
! 					have_nexttok = 1;
! 
! 					row = malloc(sizeof(PLpgSQL_row));
! 					row->dtype = PLPGSQL_DTYPE_ROW;
! 					row->refname = strdup("*internal*");
! 					row->lineno = plpgsql_scanner_lineno();
! 					row->rowtupdesc = NULL;
! 					row->nfields = nfields;
! 					row->fieldnames = malloc(sizeof(char *) * nfields);
! 					row->varnos = malloc(sizeof(int) * nfields);
! 					while (--nfields >= 0)
! 					{
! 						row->fieldnames[nfields] = fieldnames[nfields];
! 						row->varnos[nfields] = varnos[nfields];
! 					}
! 
! 					plpgsql_adddatum((PLpgSQL_datum *)row);
! 
! 					have_into = 1;
! 				}
! 				break;
  
  				default:
  					/* Treat the INTO as non-special */
  					plpgsql_dstring_append(&ds, " INTO ");
! 					have_nexttok = 1;
  					break;
  			}
  			continue;
--- 1785,1807 ----
  			{
  				case T_ROW:
  					row = yylval.row;
! 					have_into = true;
  					break;
  
  				case T_RECORD:
  					rec = yylval.rec;
! 					have_into = true;
  					break;
  
  				case T_SCALAR:
! 					row = read_into_scalar_list(yytext, yylval.scalar);
! 					have_into = true;
! 					break;
  
  				default:
  					/* Treat the INTO as non-special */
  					plpgsql_dstring_append(&ds, " INTO ");
! 					plpgsql_push_back_token(tok);
  					break;
  			}
  			continue;
***************
*** 2010,2020 ****
  				plpgsql_dstring_append(&ds, yytext);
  				break;
  		}
  	}
  
! 	expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * nparams - sizeof(int));
  	expr->dtype			= PLPGSQL_DTYPE_EXPR;
! 	expr->query			= strdup(plpgsql_dstring_get(&ds));
  	expr->plan			= NULL;
  	expr->nparams		= nparams;
  	while(nparams-- > 0)
--- 1833,1852 ----
  				plpgsql_dstring_append(&ds, yytext);
  				break;
  		}
+ 
+ 		/* Prevent array overflow */
+ 		if (nparams >= 1024)
+ 		{
+ 			plpgsql_error_lineno = plpgsql_scanner_lineno();
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
+ 					 errmsg("too many parameters specified in SQL statement")));
+ 		}
  	}
  
! 	expr = palloc(sizeof(PLpgSQL_expr) + sizeof(int) * nparams - sizeof(int));
  	expr->dtype			= PLPGSQL_DTYPE_EXPR;
! 	expr->query			= pstrdup(plpgsql_dstring_get(&ds));
  	expr->plan			= NULL;
  	expr->nparams		= nparams;
  	while(nparams-- > 0)
***************
*** 2025,2032 ****
  	{
  		PLpgSQL_stmt_select *select;
  
! 		select = malloc(sizeof(PLpgSQL_stmt_select));
! 		memset(select, 0, sizeof(PLpgSQL_stmt_select));
  		select->cmd_type = PLPGSQL_STMT_SELECT;
  		select->rec		 = rec;
  		select->row		 = row;
--- 1857,1863 ----
  	{
  		PLpgSQL_stmt_select *select;
  
! 		select = palloc0(sizeof(PLpgSQL_stmt_select));
  		select->cmd_type = PLPGSQL_STMT_SELECT;
  		select->rec		 = rec;
  		select->row		 = row;
***************
*** 2038,2044 ****
  	{
  		PLpgSQL_stmt_execsql *execsql;
  
! 		execsql = malloc(sizeof(PLpgSQL_stmt_execsql));
  		execsql->cmd_type = PLPGSQL_STMT_EXECSQL;
  		execsql->sqlstmt  = expr;
  
--- 1869,1875 ----
  	{
  		PLpgSQL_stmt_execsql *execsql;
  
! 		execsql = palloc(sizeof(PLpgSQL_stmt_execsql));
  		execsql->cmd_type = PLPGSQL_STMT_EXECSQL;
  		execsql->sqlstmt  = expr;
  
***************
*** 2054,2060 ****
  	PLpgSQL_row		   *row = NULL;
  	PLpgSQL_rec		   *rec = NULL;
  	PLpgSQL_stmt_fetch *fetch;
- 	int					have_nexttok = 0;
  
  	/* We have already parsed everything through the INTO keyword */
  
--- 1885,1890 ----
***************
*** 2070,2135 ****
  			break;
  
  		case T_SCALAR:
! 			{
! 				int				nfields = 1;
! 				char			*fieldnames[1024];
! 				int				varnos[1024];
! 
! 				check_assignable(yylval.scalar);
! 				fieldnames[0] = strdup(yytext);
! 				varnos[0]	  = yylval.scalar->dno;
! 
! 				while ((tok = yylex()) == ',')
! 				{
! 					tok = yylex();
! 					switch(tok)
! 					{
! 						case T_SCALAR:
! 							check_assignable(yylval.scalar);
! 							fieldnames[nfields] = strdup(yytext);
! 							varnos[nfields++]	= yylval.scalar->dno;
! 							break;
! 
! 						default:
! 							plpgsql_error_lineno = plpgsql_scanner_lineno();
! 							ereport(ERROR,
! 									(errcode(ERRCODE_SYNTAX_ERROR),
! 									 errmsg("\"%s\" is not a variable",
! 											yytext)));
! 					}
! 				}
! 				have_nexttok = 1;
! 
! 				row = malloc(sizeof(PLpgSQL_row));
! 				row->dtype = PLPGSQL_DTYPE_ROW;
! 				row->refname = strdup("*internal*");
! 				row->lineno = plpgsql_scanner_lineno();
! 				row->rowtupdesc = NULL;
! 				row->nfields = nfields;
! 				row->fieldnames = malloc(sizeof(char *) * nfields);
! 				row->varnos = malloc(sizeof(int) * nfields);
! 				while (--nfields >= 0)
! 				{
! 					row->fieldnames[nfields] = fieldnames[nfields];
! 					row->varnos[nfields] = varnos[nfields];
! 				}
! 
! 				plpgsql_adddatum((PLpgSQL_datum *)row);
! 			}
  			break;
  
  		default:
  			yyerror("syntax error");
  	}
  
! 	if (!have_nexttok)
! 		tok = yylex();
! 
  	if (tok != ';')
  		yyerror("syntax error");
  
! 	fetch = malloc(sizeof(PLpgSQL_stmt_select));
! 	memset(fetch, 0, sizeof(PLpgSQL_stmt_fetch));
  	fetch->cmd_type = PLPGSQL_STMT_FETCH;
  	fetch->rec		 = rec;
  	fetch->row		 = row;
--- 1900,1917 ----
  			break;
  
  		case T_SCALAR:
! 			row = read_into_scalar_list(yytext, yylval.scalar);
  			break;
  
  		default:
  			yyerror("syntax error");
  	}
  
! 	tok = yylex();
  	if (tok != ';')
  		yyerror("syntax error");
  
! 	fetch = palloc0(sizeof(PLpgSQL_stmt_select));
  	fetch->cmd_type = PLPGSQL_STMT_FETCH;
  	fetch->rec		 = rec;
  	fetch->row		 = row;
***************
*** 2174,2177 ****
--- 1956,2034 ----
  	}
  }
  
+ /*
+  * Given the first datum and name in the INTO list, continue to read
+  * comma-separated scalar variables until we run out. Then construct
+  * and return a fake "row" variable that represents the list of
+  * scalars.
+  */
+ static PLpgSQL_row *
+ read_into_scalar_list(const char *initial_name,
+ 					  PLpgSQL_datum *initial_datum)
+ {
+ 	int				 nfields;
+ 	char			*fieldnames[1024];
+ 	int				 varnos[1024];
+ 	PLpgSQL_row		*row;
+ 	int				 tok;
+ 
+ 	check_assignable(initial_datum);
+ 	fieldnames[0] = pstrdup(initial_name);
+ 	varnos[0]	  = initial_datum->dno;
+ 	nfields		  = 1;
+ 
+ 	while ((tok = yylex()) == ',')
+ 	{
+ 		/* Check for array overflow */
+ 		if (nfields >= 1024)
+ 		{
+ 			plpgsql_error_lineno = plpgsql_scanner_lineno();
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
+ 					 errmsg("too many variables specified")));
+ 		}
+ 
+ 		tok = yylex();
+ 		switch(tok)
+ 		{
+ 			case T_SCALAR:
+ 				check_assignable(yylval.scalar);
+ 				fieldnames[nfields] = pstrdup(yytext);
+ 				varnos[nfields++]	= yylval.scalar->dno;
+ 				break;
+ 
+ 			default:
+ 				plpgsql_error_lineno = plpgsql_scanner_lineno();
+ 				ereport(ERROR,
+ 						(errcode(ERRCODE_SYNTAX_ERROR),
+ 						 errmsg("\"%s\" is not a variable",
+ 								yytext)));
+ 		}
+ 	}
+ 
+ 	/*
+ 	 * We read an extra, non-comma character from yylex(), so push it
+ 	 * back onto the input stream
+ 	 */
+ 	plpgsql_push_back_token(tok);
+ 
+ 	row = palloc(sizeof(PLpgSQL_row));
+ 	row->dtype = PLPGSQL_DTYPE_ROW;
+ 	row->refname = pstrdup("*internal*");
+ 	row->lineno = plpgsql_scanner_lineno();
+ 	row->rowtupdesc = NULL;
+ 	row->nfields = nfields;
+ 	row->fieldnames = palloc(sizeof(char *) * nfields);
+ 	row->varnos = palloc(sizeof(int) * nfields);
+ 	while (--nfields >= 0)
+ 	{
+ 		row->fieldnames[nfields] = fieldnames[nfields];
+ 		row->varnos[nfields] = varnos[nfields];
+ 	}
+ 
+ 	plpgsql_adddatum((PLpgSQL_datum *)row);
+ 
+ 	return row;
+ }
+ 
  #include "pl_scan.c"
Index: src/pl/plpgsql/src/pl_comp.c
===================================================================
RCS file: /var/lib/cvs/pgsql/src/pl/plpgsql/src/pl_comp.c,v
retrieving revision 1.83
diff -c -r1.83 pl_comp.c
*** src/pl/plpgsql/src/pl_comp.c	30 Nov 2004 03:50:29 -0000	1.83
--- src/pl/plpgsql/src/pl_comp.c	6 Feb 2005 23:15:38 -0000
***************
*** 76,82 ****
  
  int			plpgsql_error_lineno;
  char	   *plpgsql_error_funcname;
! int			plpgsql_DumpExecTree = 0;
  
  PLpgSQL_function *plpgsql_curr_compile;
  
--- 76,82 ----
  
  int			plpgsql_error_lineno;
  char	   *plpgsql_error_funcname;
! bool		plpgsql_DumpExecTree = false;
  
  PLpgSQL_function *plpgsql_curr_compile;
  
***************
*** 130,153 ****
  static void plpgsql_HashTableInsert(PLpgSQL_function *function,
  						PLpgSQL_func_hashkey *func_key);
  static void plpgsql_HashTableDelete(PLpgSQL_function *function);
! 
! /*
!  * This routine is a crock, and so is everyplace that calls it.  The problem
!  * is that the compiled form of a plpgsql function is allocated permanently
!  * (mostly via malloc()) and never released until backend exit.  Subsidiary
!  * data structures such as fmgr info records therefore must live forever
!  * as well.  A better implementation would store all this stuff in a per-
!  * function memory context that could be reclaimed at need.  In the meantime,
!  * fmgr_info_cxt must be called specifying TopMemoryContext so that whatever
!  * it might allocate, and whatever the eventual function might allocate using
!  * fn_mcxt, will live forever too.
!  */
! static void
! perm_fmgr_info(Oid functionId, FmgrInfo *finfo)
! {
! 	fmgr_info_cxt(functionId, finfo, TopMemoryContext);
! }
! 
  
  /* ----------
   * plpgsql_compile		Make an execution tree for a PL/pgSQL function.
--- 130,136 ----
  static void plpgsql_HashTableInsert(PLpgSQL_function *function,
  						PLpgSQL_func_hashkey *func_key);
  static void plpgsql_HashTableDelete(PLpgSQL_function *function);
! static void delete_function(PLpgSQL_function *func);
  
  /* ----------
   * plpgsql_compile		Make an execution tree for a PL/pgSQL function.
***************
*** 187,196 ****
  
  	if (!function)
  	{
- 		/* First time through in this backend?	If so, init hashtable */
- 		if (!plpgsql_HashTable)
- 			plpgsql_HashTableInit();
- 
  		/* Compute hashkey using function signature and actual arg types */
  		compute_function_hashkey(fcinfo, procStruct, &hashkey, forValidator);
  		hashkey_valid = true;
--- 170,175 ----
***************
*** 205,216 ****
  		if (!(function->fn_xmin == HeapTupleHeaderGetXmin(procTup->t_data) &&
  		   function->fn_cmin == HeapTupleHeaderGetCmin(procTup->t_data)))
  		{
! 			/*
! 			 * Nope, drop the hashtable entry.	XXX someday, free all the
! 			 * subsidiary storage as well.
! 			 */
! 			plpgsql_HashTableDelete(function);
! 
  			function = NULL;
  		}
  	}
--- 184,191 ----
  		if (!(function->fn_xmin == HeapTupleHeaderGetXmin(procTup->t_data) &&
  		   function->fn_cmin == HeapTupleHeaderGetCmin(procTup->t_data)))
  		{
! 			/* Nope, drop the function and associated storage */
! 			delete_function(function);
  			function = NULL;
  		}
  	}
***************
*** 250,255 ****
--- 225,238 ----
  
  /*
   * This is the slow part of plpgsql_compile().
+  *
+  * While compiling a function, the CurrentMemoryContext is the
+  * per-function memory context of the function we are compiling. That
+  * means a palloc() is sufficient to allocate storage that must have
+  * the same lifetime as the function itself. Conversely, palloc()'d
+  * storage will not be immediately freed, so temporary allocations
+  * should either be performed in a short-lived memory context or
+  * explicitly pfree'd.
   */
  static PLpgSQL_function *
  do_compile(FunctionCallInfo fcinfo,
***************
*** 273,278 ****
--- 256,263 ----
  	int			parse_rc;
  	Oid			rettypeid;
  	char	  **argnames;
+ 	MemoryContext old_cxt;
+ 	MemoryContext func_cxt;
  
  	/*
  	 * Setup the scanner input and error info.	We assume that this
***************
*** 293,299 ****
  	 * Setup error traceback support for ereport()
  	 */
  	plerrcontext.callback = plpgsql_compile_error_callback;
! 	plerrcontext.arg = forValidator ? proc_source : (char *) NULL;
  	plerrcontext.previous = error_context_stack;
  	error_context_stack = &plerrcontext;
  
--- 278,284 ----
  	 * Setup error traceback support for ereport()
  	 */
  	plerrcontext.callback = plpgsql_compile_error_callback;
! 	plerrcontext.arg = forValidator ? proc_source : NULL;
  	plerrcontext.previous = error_context_stack;
  	error_context_stack = &plerrcontext;
  
***************
*** 302,331 ****
  	 */
  	plpgsql_ns_init();
  	plpgsql_ns_push(NULL);
! 	plpgsql_DumpExecTree = 0;
  
  	datums_alloc = 128;
  	plpgsql_nDatums = 0;
  	plpgsql_Datums = palloc(sizeof(PLpgSQL_datum *) * datums_alloc);
  	datums_last = 0;
  
  	/*
! 	 * Create the new function node
! 	 */
! 	function = malloc(sizeof(PLpgSQL_function));
! 	MemSet(function, 0, sizeof(PLpgSQL_function));
  	plpgsql_curr_compile = function;
  
! 	function->fn_name = strdup(NameStr(procStruct->proname));
  	function->fn_oid = fcinfo->flinfo->fn_oid;
  	function->fn_xmin = HeapTupleHeaderGetXmin(procTup->t_data);
  	function->fn_cmin = HeapTupleHeaderGetCmin(procTup->t_data);
  	function->fn_functype = functype;
  
  	switch (functype)
  	{
  		case T_FUNCTION:
- 
  			/*
  			 * Check for a polymorphic returntype. If found, use the
  			 * actual returntype type from the caller's FuncExpr node, if
--- 287,325 ----
  	 */
  	plpgsql_ns_init();
  	plpgsql_ns_push(NULL);
! 	plpgsql_DumpExecTree = false;
  
  	datums_alloc = 128;
  	plpgsql_nDatums = 0;
+ 	/* This is short-lived, so needn't allocate in function's cxt */
  	plpgsql_Datums = palloc(sizeof(PLpgSQL_datum *) * datums_alloc);
  	datums_last = 0;
  
  	/*
! 	 * Create the new function node. We allocate the function and all
! 	 * of its compile-time storage (e.g. parse tree) in its own memory
! 	 * context. This allows us to reclaim the function's storage
! 	 * cleanly.
! 	 */
! 	func_cxt = AllocSetContextCreate(TopMemoryContext,
! 									 "PL/PgSQL function context",
! 									 ALLOCSET_DEFAULT_MINSIZE,
! 									 ALLOCSET_DEFAULT_INITSIZE,
! 									 ALLOCSET_DEFAULT_MAXSIZE);
! 	old_cxt = MemoryContextSwitchTo(func_cxt);
! 	function = palloc0(sizeof(*function));
  	plpgsql_curr_compile = function;
  
! 	function->fn_name = pstrdup(NameStr(procStruct->proname));
  	function->fn_oid = fcinfo->flinfo->fn_oid;
  	function->fn_xmin = HeapTupleHeaderGetXmin(procTup->t_data);
  	function->fn_cmin = HeapTupleHeaderGetCmin(procTup->t_data);
  	function->fn_functype = functype;
+ 	function->fn_cxt = func_cxt;
  
  	switch (functype)
  	{
  		case T_FUNCTION:
  			/*
  			 * Check for a polymorphic returntype. If found, use the
  			 * actual returntype type from the caller's FuncExpr node, if
***************
*** 398,404 ****
  				function->fn_retbyval = typeStruct->typbyval;
  				function->fn_rettyplen = typeStruct->typlen;
  				function->fn_rettypioparam = getTypeIOParam(typeTup);
! 				perm_fmgr_info(typeStruct->typinput, &(function->fn_retinput));
  
  				/*
  				 * install $0 reference, but only for polymorphic return
--- 392,398 ----
  				function->fn_retbyval = typeStruct->typbyval;
  				function->fn_rettyplen = typeStruct->typlen;
  				function->fn_rettypioparam = getTypeIOParam(typeTup);
! 				fmgr_info(typeStruct->typinput, &(function->fn_retinput));
  
  				/*
  				 * install $0 reference, but only for polymorphic return
***************
*** 407,413 ****
  				if (procStruct->prorettype == ANYARRAYOID ||
  					procStruct->prorettype == ANYELEMENTOID)
  				{
! 					(void) plpgsql_build_variable(strdup("$0"), 0,
  											 build_datatype(typeTup, -1),
  												  true);
  				}
--- 401,407 ----
  				if (procStruct->prorettype == ANYARRAYOID ||
  					procStruct->prorettype == ANYELEMENTOID)
  				{
! 					(void) plpgsql_build_variable("$0", 0,
  											 build_datatype(typeTup, -1),
  												  true);
  				}
***************
*** 449,455 ****
  								 format_type_be(argtypeid))));
  
  				/* Build variable and add to datum list */
! 				argvariable = plpgsql_build_variable(strdup(buf), 0,
  													 argdtype, false);
  
  				if (argvariable->dtype == PLPGSQL_DTYPE_VAR)
--- 443,449 ----
  								 format_type_be(argtypeid))));
  
  				/* Build variable and add to datum list */
! 				argvariable = plpgsql_build_variable(buf, 0,
  													 argdtype, false);
  
  				if (argvariable->dtype == PLPGSQL_DTYPE_VAR)
***************
*** 471,499 ****
  				plpgsql_ns_additem(argitemtype, argvariable->dno, buf);
  
  				/* If there's a name for the argument, make an alias */
! 				if (argnames && argnames[i] && argnames[i][0])
  					plpgsql_ns_additem(argitemtype, argvariable->dno,
  									   argnames[i]);
  			}
  			break;
  
  		case T_TRIGGER:
! 
! 			/*
! 			 * Trigger procedures return type is unknown yet
! 			 */
  			function->fn_rettype = InvalidOid;
  			function->fn_retbyval = false;
  			function->fn_retistuple = true;
  			function->fn_retset = false;
  
! 			/*
! 			 * Add the record for referencing NEW
! 			 */
! 			rec = malloc(sizeof(PLpgSQL_rec));
! 			memset(rec, 0, sizeof(PLpgSQL_rec));
  			rec->dtype = PLPGSQL_DTYPE_REC;
! 			rec->refname = strdup("new");
  			rec->tup = NULL;
  			rec->tupdesc = NULL;
  			rec->freetup = false;
--- 465,496 ----
  				plpgsql_ns_additem(argitemtype, argvariable->dno, buf);
  
  				/* If there's a name for the argument, make an alias */
! 				if (argnames)
  					plpgsql_ns_additem(argitemtype, argvariable->dno,
  									   argnames[i]);
  			}
+ 
+ 			/* Free argument names; no longer needed */
+ 			if (argnames)
+ 			{
+ 				for (i = 0; i < procStruct->pronargs; i++)
+ 					pfree(argnames[i]);
+ 				pfree(argnames);
+ 			}
+ 
  			break;
  
  		case T_TRIGGER:
! 			/* Trigger procedure's return type is unknown yet */
  			function->fn_rettype = InvalidOid;
  			function->fn_retbyval = false;
  			function->fn_retistuple = true;
  			function->fn_retset = false;
  
! 			/* Add the record for referencing NEW */
! 			rec = palloc0(sizeof(PLpgSQL_rec));
  			rec->dtype = PLPGSQL_DTYPE_REC;
! 			rec->refname = pstrdup("new");
  			rec->tup = NULL;
  			rec->tupdesc = NULL;
  			rec->freetup = false;
***************
*** 501,513 ****
  			plpgsql_ns_additem(PLPGSQL_NSTYPE_REC, rec->recno, rec->refname);
  			function->new_varno = rec->recno;
  
! 			/*
! 			 * Add the record for referencing OLD
! 			 */
! 			rec = malloc(sizeof(PLpgSQL_rec));
! 			memset(rec, 0, sizeof(PLpgSQL_rec));
  			rec->dtype = PLPGSQL_DTYPE_REC;
! 			rec->refname = strdup("old");
  			rec->tup = NULL;
  			rec->tupdesc = NULL;
  			rec->freetup = false;
--- 498,507 ----
  			plpgsql_ns_additem(PLPGSQL_NSTYPE_REC, rec->recno, rec->refname);
  			function->new_varno = rec->recno;
  
! 			/* Add the record for referencing OLD */
! 			rec = palloc0(sizeof(PLpgSQL_rec));
  			rec->dtype = PLPGSQL_DTYPE_REC;
! 			rec->refname = pstrdup("old");
  			rec->tup = NULL;
  			rec->tupdesc = NULL;
  			rec->freetup = false;
***************
*** 515,572 ****
  			plpgsql_ns_additem(PLPGSQL_NSTYPE_REC, rec->recno, rec->refname);
  			function->old_varno = rec->recno;
  
! 			/*
! 			 * Add the variable tg_name
! 			 */
! 			var = plpgsql_build_variable(strdup("tg_name"), 0,
  									 plpgsql_build_datatype(NAMEOID, -1),
  										 true);
  			function->tg_name_varno = var->dno;
  
! 			/*
! 			 * Add the variable tg_when
! 			 */
! 			var = plpgsql_build_variable(strdup("tg_when"), 0,
  									 plpgsql_build_datatype(TEXTOID, -1),
  										 true);
  			function->tg_when_varno = var->dno;
  
! 			/*
! 			 * Add the variable tg_level
! 			 */
! 			var = plpgsql_build_variable(strdup("tg_level"), 0,
  									 plpgsql_build_datatype(TEXTOID, -1),
  										 true);
  			function->tg_level_varno = var->dno;
  
! 			/*
! 			 * Add the variable tg_op
! 			 */
! 			var = plpgsql_build_variable(strdup("tg_op"), 0,
  									 plpgsql_build_datatype(TEXTOID, -1),
  										 true);
  			function->tg_op_varno = var->dno;
  
! 			/*
! 			 * Add the variable tg_relid
! 			 */
! 			var = plpgsql_build_variable(strdup("tg_relid"), 0,
  									  plpgsql_build_datatype(OIDOID, -1),
  										 true);
  			function->tg_relid_varno = var->dno;
  
! 			/*
! 			 * Add the variable tg_relname
! 			 */
! 			var = plpgsql_build_variable(strdup("tg_relname"), 0,
  									 plpgsql_build_datatype(NAMEOID, -1),
  										 true);
  			function->tg_relname_varno = var->dno;
  
! 			/*
! 			 * Add the variable tg_nargs
! 			 */
! 			var = plpgsql_build_variable(strdup("tg_nargs"), 0,
  									 plpgsql_build_datatype(INT4OID, -1),
  										 true);
  			function->tg_nargs_varno = var->dno;
--- 509,552 ----
  			plpgsql_ns_additem(PLPGSQL_NSTYPE_REC, rec->recno, rec->refname);
  			function->old_varno = rec->recno;
  
! 			/* Add the variable tg_name */
! 			var = plpgsql_build_variable("tg_name", 0,
  									 plpgsql_build_datatype(NAMEOID, -1),
  										 true);
  			function->tg_name_varno = var->dno;
  
! 			/* Add the variable tg_when */
! 			var = plpgsql_build_variable("tg_when", 0,
  									 plpgsql_build_datatype(TEXTOID, -1),
  										 true);
  			function->tg_when_varno = var->dno;
  
! 			/* Add the variable tg_level */
! 			var = plpgsql_build_variable("tg_level", 0,
  									 plpgsql_build_datatype(TEXTOID, -1),
  										 true);
  			function->tg_level_varno = var->dno;
  
! 			/* Add the variable tg_op */
! 			var = plpgsql_build_variable("tg_op", 0,
  									 plpgsql_build_datatype(TEXTOID, -1),
  										 true);
  			function->tg_op_varno = var->dno;
  
! 			/* Add the variable tg_relid */
! 			var = plpgsql_build_variable("tg_relid", 0,
  									  plpgsql_build_datatype(OIDOID, -1),
  										 true);
  			function->tg_relid_varno = var->dno;
  
! 			/* Add the variable tg_relname */
! 			var = plpgsql_build_variable("tg_relname", 0,
  									 plpgsql_build_datatype(NAMEOID, -1),
  										 true);
  			function->tg_relname_varno = var->dno;
  
! 			/* Add the variable tg_nargs */
! 			var = plpgsql_build_variable("tg_nargs", 0,
  									 plpgsql_build_datatype(INT4OID, -1),
  										 true);
  			function->tg_nargs_varno = var->dno;
***************
*** 584,590 ****
  	/*
  	 * Create the magic FOUND variable.
  	 */
! 	var = plpgsql_build_variable(strdup("found"), 0,
  								 plpgsql_build_datatype(BOOLOID, -1),
  								 true);
  	function->found_varno = var->dno;
--- 564,570 ----
  	/*
  	 * Create the magic FOUND variable.
  	 */
! 	var = plpgsql_build_variable("found", 0,
  								 plpgsql_build_datatype(BOOLOID, -1),
  								 true);
  	function->found_varno = var->dno;
***************
*** 611,617 ****
  	for (i = 0; i < function->fn_nargs; i++)
  		function->fn_argvarnos[i] = arg_varnos[i];
  	function->ndatums = plpgsql_nDatums;
! 	function->datums = malloc(sizeof(PLpgSQL_datum *) * plpgsql_nDatums);
  	for (i = 0; i < plpgsql_nDatums; i++)
  		function->datums[i] = plpgsql_Datums[i];
  	function->action = plpgsql_yylval.program;
--- 591,597 ----
  	for (i = 0; i < function->fn_nargs; i++)
  		function->fn_argvarnos[i] = arg_varnos[i];
  	function->ndatums = plpgsql_nDatums;
! 	function->datums = palloc(sizeof(PLpgSQL_datum *) * plpgsql_nDatums);
  	for (i = 0; i < plpgsql_nDatums; i++)
  		function->datums[i] = plpgsql_Datums[i];
  	function->action = plpgsql_yylval.program;
***************
*** 632,637 ****
--- 612,619 ----
  	plpgsql_error_funcname = NULL;
  	plpgsql_error_lineno = 0;
  
+ 	MemoryContextSwitchTo(old_cxt);
+ 
  	return function;
  }
  
***************
*** 725,735 ****
  	{
  		if (strcmp(cp[0], "tg_argv") == 0)
  		{
! 			int			save_spacescanned = plpgsql_SpaceScanned;
  			PLpgSQL_trigarg *trigarg;
  
! 			trigarg = malloc(sizeof(PLpgSQL_trigarg));
! 			memset(trigarg, 0, sizeof(PLpgSQL_trigarg));
  			trigarg->dtype = PLPGSQL_DTYPE_TRIGARG;
  
  			if (plpgsql_yylex() != '[')
--- 707,716 ----
  	{
  		if (strcmp(cp[0], "tg_argv") == 0)
  		{
! 			bool save_spacescanned = plpgsql_SpaceScanned;
  			PLpgSQL_trigarg *trigarg;
  
! 			trigarg = palloc0(sizeof(PLpgSQL_trigarg));
  			trigarg->dtype = PLPGSQL_DTYPE_TRIGARG;
  
  			if (plpgsql_yylex() != '[')
***************
*** 851,859 ****
  				 */
  				PLpgSQL_recfield *new;
  
! 				new = malloc(sizeof(PLpgSQL_recfield));
  				new->dtype = PLPGSQL_DTYPE_RECFIELD;
! 				new->fieldname = strdup(cp[1]);
  				new->recparentno = ns->itemno;
  
  				plpgsql_adddatum((PLpgSQL_datum *) new);
--- 832,840 ----
  				 */
  				PLpgSQL_recfield *new;
  
! 				new = palloc(sizeof(PLpgSQL_recfield));
  				new->dtype = PLPGSQL_DTYPE_RECFIELD;
! 				new->fieldname = pstrdup(cp[1]);
  				new->recparentno = ns->itemno;
  
  				plpgsql_adddatum((PLpgSQL_datum *) new);
***************
*** 957,965 ****
  				 */
  				PLpgSQL_recfield *new;
  
! 				new = malloc(sizeof(PLpgSQL_recfield));
  				new->dtype = PLPGSQL_DTYPE_RECFIELD;
! 				new->fieldname = strdup(cp[2]);
  				new->recparentno = ns->itemno;
  
  				plpgsql_adddatum((PLpgSQL_datum *) new);
--- 938,946 ----
  				 */
  				PLpgSQL_recfield *new;
  
! 				new = palloc(sizeof(PLpgSQL_recfield));
  				new->dtype = PLPGSQL_DTYPE_RECFIELD;
! 				new->fieldname = pstrdup(cp[2]);
  				new->recparentno = ns->itemno;
  
  				plpgsql_adddatum((PLpgSQL_datum *) new);
***************
*** 1038,1044 ****
  	pfree(cp[1]);
  
  	/*
! 	 * Do a lookup on the compilers namestack. But ensure it moves up to
  	 * the toplevel.
  	 */
  	old_nsstate = plpgsql_ns_setlocal(false);
--- 1019,1025 ----
  	pfree(cp[1]);
  
  	/*
! 	 * Do a lookup on the compiler's namestack. But ensure it moves up to
  	 * the toplevel.
  	 */
  	old_nsstate = plpgsql_ns_setlocal(false);
***************
*** 1433,1446 ****
  }
  
  /*
!  * plpgsql_build_variable - build a datum-array entry of a given datatype
   *
!  * The returned struct may be a PLpgSQL_var, PLpgSQL_row, or PLpgSQL_rec
!  * depending on the given datatype.  The struct is automatically added
!  * to the current datum array, and optionally to the current namespace.
   */
  PLpgSQL_variable *
! plpgsql_build_variable(char *refname, int lineno, PLpgSQL_type *dtype,
  					   bool add2namespace)
  {
  	PLpgSQL_variable *result;
--- 1414,1429 ----
  }
  
  /*
!  * plpgsql_build_variable - build a datum-array entry of a given
!  * datatype
   *
!  * The returned struct may be a PLpgSQL_var, PLpgSQL_row, or
!  * PLpgSQL_rec depending on the given datatype, and is allocated via
!  * palloc.  The struct is automatically added to the current datum
!  * array, and optionally to the current namespace.
   */
  PLpgSQL_variable *
! plpgsql_build_variable(const char *refname, int lineno, PLpgSQL_type *dtype,
  					   bool add2namespace)
  {
  	PLpgSQL_variable *result;
***************
*** 1452,1462 ****
  				/* Ordinary scalar datatype */
  				PLpgSQL_var *var;
  
! 				var = malloc(sizeof(PLpgSQL_var));
! 				memset(var, 0, sizeof(PLpgSQL_var));
! 
  				var->dtype = PLPGSQL_DTYPE_VAR;
! 				var->refname = refname;
  				var->lineno = lineno;
  				var->datatype = dtype;
  				/* other fields might be filled by caller */
--- 1435,1443 ----
  				/* Ordinary scalar datatype */
  				PLpgSQL_var *var;
  
! 				var = palloc0(sizeof(PLpgSQL_var));
  				var->dtype = PLPGSQL_DTYPE_VAR;
! 				var->refname = pstrdup(refname);
  				var->lineno = lineno;
  				var->datatype = dtype;
  				/* other fields might be filled by caller */
***************
*** 1482,1488 ****
  				row = build_row_var(dtype->typrelid);
  
  				row->dtype = PLPGSQL_DTYPE_ROW;
! 				row->refname = refname;
  				row->lineno = lineno;
  
  				plpgsql_adddatum((PLpgSQL_datum *) row);
--- 1463,1469 ----
  				row = build_row_var(dtype->typrelid);
  
  				row->dtype = PLPGSQL_DTYPE_ROW;
! 				row->refname = pstrdup(refname);
  				row->lineno = lineno;
  
  				plpgsql_adddatum((PLpgSQL_datum *) row);
***************
*** 1501,1511 ****
  				 */
  				PLpgSQL_rec *rec;
  
! 				rec = malloc(sizeof(PLpgSQL_rec));
! 				memset(rec, 0, sizeof(PLpgSQL_rec));
! 
  				rec->dtype = PLPGSQL_DTYPE_REC;
! 				rec->refname = refname;
  				rec->lineno = lineno;
  
  				plpgsql_adddatum((PLpgSQL_datum *) rec);
--- 1482,1490 ----
  				 */
  				PLpgSQL_rec *rec;
  
! 				rec = palloc0(sizeof(PLpgSQL_rec));
  				rec->dtype = PLPGSQL_DTYPE_REC;
! 				rec->refname = pstrdup(refname);
  				rec->lineno = lineno;
  
  				plpgsql_adddatum((PLpgSQL_datum *) rec);
***************
*** 1517,1530 ****
  				break;
  			}
  		case PLPGSQL_TTYPE_PSEUDO:
! 			{
! 				ereport(ERROR,
! 						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 						 errmsg("variable \"%s\" has pseudo-type %s",
! 								refname, format_type_be(dtype->typoid))));
! 				result = NULL;	/* keep compiler quiet */
! 				break;
! 			}
  		default:
  			elog(ERROR, "unrecognized ttype: %d", dtype->ttype);
  			result = NULL;		/* keep compiler quiet */
--- 1496,1507 ----
  				break;
  			}
  		case PLPGSQL_TTYPE_PSEUDO:
! 			ereport(ERROR,
! 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("variable \"%s\" has pseudo-type %s",
! 							refname, format_type_be(dtype->typoid))));
! 			result = NULL;	/* keep compiler quiet */
! 			break;
  		default:
  			elog(ERROR, "unrecognized ttype: %d", dtype->ttype);
  			result = NULL;		/* keep compiler quiet */
***************
*** 1545,1551 ****
  	Form_pg_class classStruct;
  	const char *relname;
  	int			i;
- 	MemoryContext oldcxt;
  
  	/*
  	 * Open the relation to get info.
--- 1522,1527 ----
***************
*** 1567,1589 ****
  	 * Create a row datum entry and all the required variables that it
  	 * will point to.
  	 */
! 	row = malloc(sizeof(PLpgSQL_row));
! 	memset(row, 0, sizeof(PLpgSQL_row));
! 
  	row->dtype = PLPGSQL_DTYPE_ROW;
- 
- 	/*
- 	 * This is a bit ugly --- need a permanent copy of the rel's tupdesc.
- 	 * Someday all these mallocs should go away in favor of a per-function
- 	 * memory context ...
- 	 */
- 	oldcxt = MemoryContextSwitchTo(TopMemoryContext);
  	row->rowtupdesc = CreateTupleDescCopy(RelationGetDescr(rel));
- 	MemoryContextSwitchTo(oldcxt);
- 
  	row->nfields = classStruct->relnatts;
! 	row->fieldnames = malloc(sizeof(char *) * row->nfields);
! 	row->varnos = malloc(sizeof(int) * row->nfields);
  
  	for (i = 0; i < row->nfields; i++)
  	{
--- 1543,1554 ----
  	 * Create a row datum entry and all the required variables that it
  	 * will point to.
  	 */
! 	row = palloc0(sizeof(PLpgSQL_row));
  	row->dtype = PLPGSQL_DTYPE_ROW;
  	row->rowtupdesc = CreateTupleDescCopy(RelationGetDescr(rel));
  	row->nfields = classStruct->relnatts;
! 	row->fieldnames = palloc(sizeof(char *) * row->nfields);
! 	row->varnos = palloc(sizeof(int) * row->nfields);
  
  	for (i = 0; i < row->nfields; i++)
  	{
***************
*** 1592,1610 ****
  		/*
  		 * Get the attribute and check for dropped column
  		 */
! 		attrStruct = RelationGetDescr(rel)->attrs[i];
  
  		if (!attrStruct->attisdropped)
  		{
! 			const char *attname;
! 			char	   *refname;
  			PLpgSQL_variable *var;
  
  			attname = NameStr(attrStruct->attname);
! 			refname = malloc(strlen(relname) + strlen(attname) + 2);
! 			strcpy(refname, relname);
! 			strcat(refname, ".");
! 			strcat(refname, attname);
  
  			/*
  			 * Create the internal variable for the field
--- 1557,1572 ----
  		/*
  		 * Get the attribute and check for dropped column
  		 */
! 		attrStruct = row->rowtupdesc->attrs[i];
  
  		if (!attrStruct->attisdropped)
  		{
! 			char	   *attname;
! 			char		refname[(NAMEDATALEN * 2) + 100];
  			PLpgSQL_variable *var;
  
  			attname = NameStr(attrStruct->attname);
! 			snprintf(refname, sizeof(refname), "%s.%s", relname, attname);
  
  			/*
  			 * Create the internal variable for the field
***************
*** 1621,1630 ****
  												  attrStruct->atttypmod),
  										 false);
  
! 			/*
! 			 * Add the variable to the row.
! 			 */
! 			row->fieldnames[i] = strdup(attname);
  			row->varnos[i] = var->dno;
  		}
  		else
--- 1583,1590 ----
  												  attrStruct->atttypmod),
  										 false);
  
! 			/* Add the variable to the row. */
! 			row->fieldnames[i] = attname;
  			row->varnos[i] = var->dno;
  		}
  		else
***************
*** 1697,1705 ****
  				 errmsg("type \"%s\" is only a shell",
  						NameStr(typeStruct->typname))));
  
! 	typ = (PLpgSQL_type *) malloc(sizeof(PLpgSQL_type));
  
! 	typ->typname = strdup(NameStr(typeStruct->typname));
  	typ->typoid = HeapTupleGetOid(typeTup);
  	switch (typeStruct->typtype)
  	{
--- 1657,1665 ----
  				 errmsg("type \"%s\" is only a shell",
  						NameStr(typeStruct->typname))));
  
! 	typ = (PLpgSQL_type *) palloc(sizeof(PLpgSQL_type));
  
! 	typ->typname = pstrdup(NameStr(typeStruct->typname));
  	typ->typoid = HeapTupleGetOid(typeTup);
  	switch (typeStruct->typtype)
  	{
***************
*** 1726,1732 ****
  	typ->typbyval = typeStruct->typbyval;
  	typ->typrelid = typeStruct->typrelid;
  	typ->typioparam = getTypeIOParam(typeTup);
! 	perm_fmgr_info(typeStruct->typinput, &(typ->typinput));
  	typ->atttypmod = typmod;
  
  	return typ;
--- 1686,1692 ----
  	typ->typbyval = typeStruct->typbyval;
  	typ->typrelid = typeStruct->typrelid;
  	typ->typioparam = getTypeIOParam(typeTup);
! 	fmgr_info(typeStruct->typinput, &(typ->typinput));
  	typ->atttypmod = typmod;
  
  	return typ;
***************
*** 1757,1763 ****
  	 */
  	if (strcmp(condname, "others") == 0)
  	{
! 		new = malloc(sizeof(PLpgSQL_condition));
  		new->sqlerrstate = 0;
  		new->condname = condname;
  		new->next = NULL;
--- 1717,1723 ----
  	 */
  	if (strcmp(condname, "others") == 0)
  	{
! 		new = palloc(sizeof(PLpgSQL_condition));
  		new->sqlerrstate = 0;
  		new->condname = condname;
  		new->next = NULL;
***************
*** 1769,1775 ****
  	{
  		if (strcmp(condname, exception_label_map[i].label) == 0)
  		{
! 			new = malloc(sizeof(PLpgSQL_condition));
  			new->sqlerrstate = exception_label_map[i].sqlerrstate;
  			new->condname = condname;
  			new->next = prev;
--- 1729,1735 ----
  	{
  		if (strcmp(condname, exception_label_map[i].label) == 0)
  		{
! 			new = palloc(sizeof(PLpgSQL_condition));
  			new->sqlerrstate = exception_label_map[i].sqlerrstate;
  			new->condname = condname;
  			new->next = prev;
***************
*** 1836,1842 ****
  	{
  		if (n > 0)
  		{
! 			*varnos = (int *) malloc(sizeof(int) * n);
  
  			n = 0;
  			for (i = datums_last; i < plpgsql_nDatums; i++)
--- 1796,1802 ----
  	{
  		if (n > 0)
  		{
! 			*varnos = (int *) palloc(sizeof(int) * n);
  
  			n = 0;
  			for (i = datums_last; i < plpgsql_nDatums; i++)
***************
*** 1930,1941 ****
--- 1890,1919 ----
  	}
  }
  
+ static void
+ delete_function(PLpgSQL_function *func)
+ {
+ 	/* remove function from hash table */
+ 	plpgsql_HashTableDelete(func);
+ 
+ 	/* release the function's storage */
+ 	MemoryContextDelete(func->fn_cxt);
+ 
+ 	/*
+ 	 * Caller should be sure not to use passed-in pointer, as it now
+ 	 * points to pfree'd storage
+ 	 */
+ }
+ 
  /* exported so we can call it from plpgsql_init() */
  void
  plpgsql_HashTableInit(void)
  {
  	HASHCTL		ctl;
  
+ 	/* don't allow double-initialization */
+ 	Assert(plpgsql_HashTable == NULL);
+ 
  	memset(&ctl, 0, sizeof(ctl));
  	ctl.keysize = sizeof(PLpgSQL_func_hashkey);
  	ctl.entrysize = sizeof(plpgsql_HashEnt);
Index: src/pl/plpgsql/src/pl_exec.c
===================================================================
RCS file: /var/lib/cvs/pgsql/src/pl/plpgsql/src/pl_exec.c,v
retrieving revision 1.128
diff -c -r1.128 pl_exec.c
*** src/pl/plpgsql/src/pl_exec.c	1 Feb 2005 19:35:14 -0000	1.128
--- src/pl/plpgsql/src/pl_exec.c	6 Feb 2005 23:15:38 -0000
***************
*** 74,86 ****
   * Local function forward declarations
   ************************************************************/
  static void plpgsql_exec_error_callback(void *arg);
  static PLpgSQL_var *copy_var(PLpgSQL_var *var);
  static PLpgSQL_rec *copy_rec(PLpgSQL_rec *rec);
  
  static int exec_stmt_block(PLpgSQL_execstate *estate,
  				PLpgSQL_stmt_block *block);
  static int exec_stmts(PLpgSQL_execstate *estate,
! 		   PLpgSQL_stmts *stmts);
  static int exec_stmt(PLpgSQL_execstate *estate,
  		  PLpgSQL_stmt *stmt);
  static int exec_stmt_assign(PLpgSQL_execstate *estate,
--- 74,87 ----
   * Local function forward declarations
   ************************************************************/
  static void plpgsql_exec_error_callback(void *arg);
+ static PLpgSQL_datum *copy_plpgsql_datum(PLpgSQL_datum *datum);
  static PLpgSQL_var *copy_var(PLpgSQL_var *var);
  static PLpgSQL_rec *copy_rec(PLpgSQL_rec *rec);
  
  static int exec_stmt_block(PLpgSQL_execstate *estate,
  				PLpgSQL_stmt_block *block);
  static int exec_stmts(PLpgSQL_execstate *estate,
! 					  List *stmts);
  static int exec_stmt(PLpgSQL_execstate *estate,
  		  PLpgSQL_stmt *stmt);
  static int exec_stmt_assign(PLpgSQL_execstate *estate,
***************
*** 212,240 ****
  	 */
  	estate.err_text = gettext_noop("during initialization of execution state");
  	for (i = 0; i < func->ndatums; i++)
! 	{
! 		switch (func->datums[i]->dtype)
! 		{
! 			case PLPGSQL_DTYPE_VAR:
! 				estate.datums[i] = (PLpgSQL_datum *)
! 					copy_var((PLpgSQL_var *) (func->datums[i]));
! 				break;
! 
! 			case PLPGSQL_DTYPE_REC:
! 				estate.datums[i] = (PLpgSQL_datum *)
! 					copy_rec((PLpgSQL_rec *) (func->datums[i]));
! 				break;
! 
! 			case PLPGSQL_DTYPE_ROW:
! 			case PLPGSQL_DTYPE_RECFIELD:
! 			case PLPGSQL_DTYPE_ARRAYELEM:
! 				estate.datums[i] = func->datums[i];
! 				break;
! 
! 			default:
! 				elog(ERROR, "unrecognized dtype: %d", func->datums[i]->dtype);
! 		}
! 	}
  
  	/*
  	 * Store the actual call argument values into the variables
--- 213,219 ----
  	 */
  	estate.err_text = gettext_noop("during initialization of execution state");
  	for (i = 0; i < func->ndatums; i++)
! 		estate.datums[i] = copy_plpgsql_datum(func->datums[i]);
  
  	/*
  	 * Store the actual call argument values into the variables
***************
*** 467,496 ****
  	 */
  	estate.err_text = gettext_noop("during initialization of execution state");
  	for (i = 0; i < func->ndatums; i++)
! 	{
! 		switch (func->datums[i]->dtype)
! 		{
! 			case PLPGSQL_DTYPE_VAR:
! 				estate.datums[i] = (PLpgSQL_datum *)
! 					copy_var((PLpgSQL_var *) (func->datums[i]));
! 				break;
! 
! 			case PLPGSQL_DTYPE_REC:
! 				estate.datums[i] = (PLpgSQL_datum *)
! 					copy_rec((PLpgSQL_rec *) (func->datums[i]));
! 				break;
! 
! 			case PLPGSQL_DTYPE_ROW:
! 			case PLPGSQL_DTYPE_RECFIELD:
! 			case PLPGSQL_DTYPE_ARRAYELEM:
! 			case PLPGSQL_DTYPE_TRIGARG:
! 				estate.datums[i] = func->datums[i];
! 				break;
! 
! 			default:
! 				elog(ERROR, "unrecognized dtype: %d", func->datums[i]->dtype);
! 		}
! 	}
  
  	/*
  	 * Put the OLD and NEW tuples into record variables
--- 446,452 ----
  	 */
  	estate.err_text = gettext_noop("during initialization of execution state");
  	for (i = 0; i < func->ndatums; i++)
! 		estate.datums[i] = copy_plpgsql_datum(func->datums[i]);
  
  	/*
  	 * Put the OLD and NEW tuples into record variables
***************
*** 758,763 ****
--- 714,748 ----
   * Support functions for copying local execution variables
   * ----------
   */
+ static PLpgSQL_datum *
+ copy_plpgsql_datum(PLpgSQL_datum *datum)
+ {
+ 	PLpgSQL_datum *result = NULL;
+ 
+ 	switch (datum->dtype)
+ 	{
+ 		case PLPGSQL_DTYPE_VAR:
+ 			result = (PLpgSQL_datum *) copy_var((PLpgSQL_var *) datum);
+ 			break;
+ 
+ 		case PLPGSQL_DTYPE_REC:
+ 			result = (PLpgSQL_datum *) copy_rec((PLpgSQL_rec *) datum);
+ 			break;
+ 
+ 		case PLPGSQL_DTYPE_ROW:
+ 		case PLPGSQL_DTYPE_RECFIELD:
+ 		case PLPGSQL_DTYPE_ARRAYELEM:
+ 		case PLPGSQL_DTYPE_TRIGARG:
+ 			result = datum;
+ 			break;
+ 
+ 		default:
+ 			elog(ERROR, "unrecognized dtype: %d", datum->dtype);
+ 	}
+ 
+ 	return result;
+ }
+ 
  static PLpgSQL_var *
  copy_var(PLpgSQL_var *var)
  {
***************
*** 920,928 ****
  		}
  		PG_CATCH();
  		{
! 			ErrorData  *edata;
! 			PLpgSQL_exceptions *exceptions;
! 			int			j;
  
  			/* Save error info */
  			MemoryContextSwitchTo(oldcontext);
--- 905,912 ----
  		}
  		PG_CATCH();
  		{
! 			ErrorData	*edata;
! 			ListCell	*e;
  
  			/* Save error info */
  			MemoryContextSwitchTo(oldcontext);
***************
*** 942,951 ****
  			SPI_restore_connection();
  
  			/* Look for a matching exception handler */
! 			exceptions = block->exceptions;
! 			for (j = 0; j < exceptions->exceptions_used; j++)
  			{
! 				PLpgSQL_exception *exception = exceptions->exceptions[j];
  
  				if (exception_matches_conditions(edata, exception->conditions))
  				{
--- 926,934 ----
  			SPI_restore_connection();
  
  			/* Look for a matching exception handler */
! 			foreach (e, block->exceptions)
  			{
! 				PLpgSQL_exception *exception = (PLpgSQL_exception *) lfirst(e);
  
  				if (exception_matches_conditions(edata, exception->conditions))
  				{
***************
*** 955,961 ****
  			}
  
  			/* If no match found, re-throw the error */
! 			if (j >= exceptions->exceptions_used)
  				ReThrowError(edata);
  			else
  				FreeErrorData(edata);
--- 938,944 ----
  			}
  
  			/* If no match found, re-throw the error */
! 			if (e == NULL)
  				ReThrowError(edata);
  			else
  				FreeErrorData(edata);
***************
*** 1005,1018 ****
   * ----------
   */
  static int
! exec_stmts(PLpgSQL_execstate *estate, PLpgSQL_stmts *stmts)
  {
! 	int			rc;
! 	int			i;
  
! 	for (i = 0; i < stmts->stmts_used; i++)
  	{
! 		rc = exec_stmt(estate, stmts->stmts[i]);
  		if (rc != PLPGSQL_RC_OK)
  			return rc;
  	}
--- 988,1001 ----
   * ----------
   */
  static int
! exec_stmts(PLpgSQL_execstate *estate, List *stmts)
  {
! 	ListCell   *s;
  
! 	foreach (s, stmts)
  	{
! 		PLpgSQL_stmt *stmt = (PLpgSQL_stmt *) lfirst(s);
! 		int rc = exec_stmt(estate, stmt);
  		if (rc != PLPGSQL_RC_OK)
  			return rc;
  	}
***************
*** 1184,1206 ****
  static int
  exec_stmt_getdiag(PLpgSQL_execstate *estate, PLpgSQL_stmt_getdiag *stmt)
  {
! 	int			i;
! 	PLpgSQL_datum *var;
! 	bool		isnull = false;
  
! 	for (i = 0; i < stmt->ndtitems; i++)
  	{
! 		PLpgSQL_diag_item *dtitem = &stmt->dtitems[i];
  
! 		if (dtitem->target <= 0)
  			continue;
  
! 		var = (estate->datums[dtitem->target]);
  
  		if (var == NULL)
  			continue;
  
! 		switch (dtitem->item)
  		{
  			case PLPGSQL_GETDIAG_ROW_COUNT:
  
--- 1167,1189 ----
  static int
  exec_stmt_getdiag(PLpgSQL_execstate *estate, PLpgSQL_stmt_getdiag *stmt)
  {
! 	ListCell *lc;
  
! 	foreach (lc, stmt->diag_items)
  	{
! 		PLpgSQL_diag_item	*diag_item = (PLpgSQL_diag_item *) lfirst(lc);
! 		PLpgSQL_datum		*var;
! 		bool				 isnull = false;
  
! 		if (diag_item->target <= 0)
  			continue;
  
! 		var = estate->datums[diag_item->target];
  
  		if (var == NULL)
  			continue;
  
! 		switch (diag_item->kind)
  		{
  			case PLPGSQL_GETDIAG_ROW_COUNT:
  
***************
*** 1218,1224 ****
  
  			default:
  				elog(ERROR, "unrecognized attribute request: %d",
! 					 dtitem->item);
  		}
  	}
  
--- 1201,1207 ----
  
  			default:
  				elog(ERROR, "unrecognized attribute request: %d",
! 					 diag_item->kind);
  		}
  	}
  
***************
*** 1242,1253 ****
  
  	if (!isnull && value)
  	{
! 		if (stmt->true_body != NULL)
  			return exec_stmts(estate, stmt->true_body);
  	}
  	else
  	{
! 		if (stmt->false_body != NULL)
  			return exec_stmts(estate, stmt->false_body);
  	}
  
--- 1225,1236 ----
  
  	if (!isnull && value)
  	{
! 		if (stmt->true_body != NIL)
  			return exec_stmts(estate, stmt->true_body);
  	}
  	else
  	{
! 		if (stmt->false_body != NIL)
  			return exec_stmts(estate, stmt->false_body);
  	}
  
***************
*** 1903,1940 ****
  static int
  exec_stmt_raise(PLpgSQL_execstate *estate, PLpgSQL_stmt_raise *stmt)
  {
- 	Oid			paramtypeid;
- 	Datum		paramvalue;
- 	bool		paramisnull;
- 	char	   *extval;
- 	int			pidx = 0;
- 	char		c[2] = {0, 0};
  	char	   *cp;
  	PLpgSQL_dstring ds;
  
  	plpgsql_dstring_init(&ds);
  
  	for (cp = stmt->message; *cp; cp++)
  	{
  		/*
! 		 * Occurrences of a single % are replaced by the next argument's
  		 * external representation. Double %'s are converted to one %.
  		 */
! 		if ((c[0] = *cp) == '%')
  		{
! 			cp++;
! 			if (*cp == '%')
! 			{
! 				plpgsql_dstring_append(&ds, c);
! 				continue;
! 			}
! 			cp--;
! 			if (pidx >= stmt->nparams)
  			{
! 				plpgsql_dstring_append(&ds, c);
  				continue;
  			}
! 			exec_eval_datum(estate, estate->datums[stmt->params[pidx]],
  							InvalidOid,
  							&paramtypeid, &paramvalue, &paramisnull);
  			if (paramisnull)
--- 1886,1924 ----
  static int
  exec_stmt_raise(PLpgSQL_execstate *estate, PLpgSQL_stmt_raise *stmt)
  {
  	char	   *cp;
  	PLpgSQL_dstring ds;
+ 	ListCell   *current_param;
  
  	plpgsql_dstring_init(&ds);
+ 	current_param = list_head(stmt->params);
  
  	for (cp = stmt->message; *cp; cp++)
  	{
  		/*
! 		 * Occurrences of a single % are replaced by the next parameter's
  		 * external representation. Double %'s are converted to one %.
  		 */
! 		if (cp[0] == '%')
  		{
! 			Oid			paramtypeid;
! 			Datum		paramvalue;
! 			bool		paramisnull;
! 			char	   *extval;
! 
! 			if (cp[1] == '%')
  			{
! 				plpgsql_dstring_append_char(&ds, cp[1]);
! 				cp++;
  				continue;
  			}
! 
! 			if (current_param == NULL)
! 				ereport(ERROR,
! 						(errcode(ERRCODE_SYNTAX_ERROR),
! 						 errmsg("too few parameters specified for RAISE")));
! 
! 			exec_eval_datum(estate, estate->datums[lfirst_int(current_param)],
  							InvalidOid,
  							&paramtypeid, &paramvalue, &paramisnull);
  			if (paramisnull)
***************
*** 1942,1955 ****
  			else
  				extval = convert_value_to_string(paramvalue, paramtypeid);
  			plpgsql_dstring_append(&ds, extval);
! 			pidx++;
  			continue;
  		}
  
! 		plpgsql_dstring_append(&ds, c);
  	}
  
  	/*
  	 * Throw the error (may or may not come back)
  	 */
  	estate->err_text = raise_skip_msg;	/* suppress traceback of raise */
--- 1926,1948 ----
  			else
  				extval = convert_value_to_string(paramvalue, paramtypeid);
  			plpgsql_dstring_append(&ds, extval);
! 			current_param = lnext(current_param);
  			continue;
  		}
  
! 		plpgsql_dstring_append_char(&ds, cp[0]);
  	}
  
  	/*
+ 	 * If more parameters were specified than were required to process
+ 	 * the format string, throw an error
+ 	 */
+ 	if (current_param != NULL)
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_SYNTAX_ERROR),
+ 				 errmsg("too many parameters specified for RAISE")));
+ 
+ 	/*
  	 * Throw the error (may or may not come back)
  	 */
  	estate->err_text = raise_skip_msg;	/* suppress traceback of raise */
Index: src/pl/plpgsql/src/pl_funcs.c
===================================================================
RCS file: /var/lib/cvs/pgsql/src/pl/plpgsql/src/pl_funcs.c,v
retrieving revision 1.38
diff -c -r1.38 pl_funcs.c
*** src/pl/plpgsql/src/pl_funcs.c	10 Oct 2004 23:37:45 -0000	1.38
--- src/pl/plpgsql/src/pl_funcs.c	6 Feb 2005 23:15:38 -0000
***************
*** 59,65 ****
  plpgsql_dstring_init(PLpgSQL_dstring *ds)
  {
  	ds->value = palloc(ds->alloc = 512);
! 	ds->used = 0;
  	ds->value[0] = '\0';
  }
  
--- 59,65 ----
  plpgsql_dstring_init(PLpgSQL_dstring *ds)
  {
  	ds->value = palloc(ds->alloc = 512);
! 	ds->used = 1;
  	ds->value[0] = '\0';
  }
  
***************
*** 74,79 ****
--- 74,93 ----
  	pfree(ds->value);
  }
  
+ static void
+ plpgsql_dstring_expand(PLpgSQL_dstring *ds, int needed)
+ {
+ 	/* Don't allow truncating the string */
+ 	Assert(needed > ds->alloc);
+ 	Assert(ds->used <= ds->alloc);
+ 
+ 	/* Might have to double more than once, if needed is large */
+ 	do
+ 	{
+ 		ds->alloc *= 2;
+ 	} while (needed > ds->alloc);
+ 	ds->value = repalloc(ds->value, ds->alloc);
+ }
  
  /* ----------
   * plpgsql_dstring_append		Dynamic string extending
***************
*** 83,102 ****
  plpgsql_dstring_append(PLpgSQL_dstring *ds, const char *str)
  {
  	int			len = strlen(str);
! 	int			needed = ds->used + len + 1;
  
  	if (needed > ds->alloc)
! 	{
! 		/* might have to double more than once, if len is large */
! 		do
! 		{
! 			ds->alloc *= 2;
! 		} while (needed > ds->alloc);
! 		ds->value = repalloc(ds->value, ds->alloc);
! 	}
  
! 	strcpy(&(ds->value[ds->used]), str);
  	ds->used += len;
  }
  
  
--- 97,126 ----
  plpgsql_dstring_append(PLpgSQL_dstring *ds, const char *str)
  {
  	int			len = strlen(str);
! 	int			needed = ds->used + len;
  
  	if (needed > ds->alloc)
! 		plpgsql_dstring_expand(ds, needed);
  
! 	memcpy(&(ds->value[ds->used - 1]), str, len);
  	ds->used += len;
+ 	ds->value[ds->used - 1] = '\0';
+ }
+ 
+ /* ----------
+  * plpgsql_dstring_append_char	Append a single character
+  *								to a dynamic string
+  * ----------
+  */
+ void
+ plpgsql_dstring_append_char(PLpgSQL_dstring *ds, char c)
+ {
+ 	if (ds->used == ds->alloc)
+ 		plpgsql_dstring_expand(ds, ds->used + 1);
+ 
+ 	ds->value[ds->used - 1] = c;
+ 	ds->value[ds->used] = '\0';
+ 	ds->used++;
  }
  
  
***************
*** 187,193 ****
   * ----------
   */
  void
! plpgsql_ns_additem(int itemtype, int itemno, char *name)
  {
  	PLpgSQL_ns *ns = ns_current;
  	PLpgSQL_nsitem *nse;
--- 211,217 ----
   * ----------
   */
  void
! plpgsql_ns_additem(int itemtype, int itemno, const char *name)
  {
  	PLpgSQL_ns *ns = ns_current;
  	PLpgSQL_nsitem *nse;
***************
*** 286,296 ****
  	int			i;
  
  	/*
! 	 * Lookup in the current namespace only
! 	 */
! 
! 	/*
! 	 * Lookup name in the namestack
  	 */
  	for (ns = ns_current; ns != NULL; ns = ns->upper)
  	{
--- 310,317 ----
  	int			i;
  
  	/*
! 	 * Lookup name in the namestack; do the lookup in the current
! 	 * namespace only.
  	 */
  	for (ns = ns_current; ns != NULL; ns = ns->upper)
  	{
***************
*** 584,603 ****
  }
  
  static void
! dump_stmts(PLpgSQL_stmts *stmts)
  {
! 	int			i;
  
  	dump_indent += 2;
! 	for (i = 0; i < stmts->stmts_used; i++)
! 		dump_stmt(stmts->stmts[i]);
  	dump_indent -= 2;
  }
  
  static void
  dump_block(PLpgSQL_stmt_block *block)
  {
- 	int			i;
  	char	   *name;
  
  	if (block->label == NULL)
--- 605,623 ----
  }
  
  static void
! dump_stmts(List *stmts)
  {
! 	ListCell *s;
  
  	dump_indent += 2;
! 	foreach (s, stmts)
! 		dump_stmt((PLpgSQL_stmt *) lfirst(s));
  	dump_indent -= 2;
  }
  
  static void
  dump_block(PLpgSQL_stmt_block *block)
  {
  	char	   *name;
  
  	if (block->label == NULL)
***************
*** 612,620 ****
  
  	if (block->exceptions)
  	{
! 		for (i = 0; i < block->exceptions->exceptions_used; i++)
  		{
! 			PLpgSQL_exception *exc = block->exceptions->exceptions[i];
  			PLpgSQL_condition *cond;
  
  			dump_ind();
--- 632,642 ----
  
  	if (block->exceptions)
  	{
! 		ListCell *e;
! 
! 		foreach (e, block->exceptions)
  		{
! 			PLpgSQL_exception *exc = (PLpgSQL_exception *) lfirst(e);
  			PLpgSQL_condition *cond;
  
  			dump_ind();
***************
*** 863,874 ****
  static void
  dump_raise(PLpgSQL_stmt_raise *stmt)
  {
! 	int			i;
  
  	dump_ind();
  	printf("RAISE '%s'", stmt->message);
! 	for (i = 0; i < stmt->nparams; i++)
! 		printf(" %d", stmt->params[i]);
  	printf("\n");
  }
  
--- 885,896 ----
  static void
  dump_raise(PLpgSQL_stmt_raise *stmt)
  {
! 	ListCell *l;
  
  	dump_ind();
  	printf("RAISE '%s'", stmt->message);
! 	foreach (l, stmt->params)
! 		printf(" %d", lfirst_int(l));
  	printf("\n");
  }
  
***************
*** 907,926 ****
  static void
  dump_getdiag(PLpgSQL_stmt_getdiag *stmt)
  {
! 	int			i;
  
  	dump_ind();
  	printf("GET DIAGNOSTICS ");
! 	for (i = 0; i < stmt->ndtitems; i++)
  	{
! 		PLpgSQL_diag_item *dtitem = &stmt->dtitems[i];
  
! 		if (i != 0)
  			printf(", ");
  
! 		printf("{var %d} = ", dtitem->target);
  
! 		switch (dtitem->item)
  		{
  			case PLPGSQL_GETDIAG_ROW_COUNT:
  				printf("ROW_COUNT");
--- 929,948 ----
  static void
  dump_getdiag(PLpgSQL_stmt_getdiag *stmt)
  {
! 	ListCell *lc;
  
  	dump_ind();
  	printf("GET DIAGNOSTICS ");
! 	foreach (lc, stmt->diag_items)
  	{
! 		PLpgSQL_diag_item *diag_item = (PLpgSQL_diag_item *) lfirst(lc);
  
! 		if (lc != list_head(stmt->diag_items))
  			printf(", ");
  
! 		printf("{var %d} = ", diag_item->target);
  
! 		switch (diag_item->kind)
  		{
  			case PLPGSQL_GETDIAG_ROW_COUNT:
  				printf("ROW_COUNT");
Index: src/pl/plpgsql/src/pl_handler.c
===================================================================
RCS file: /var/lib/cvs/pgsql/src/pl/plpgsql/src/pl_handler.c,v
retrieving revision 1.23
diff -c -r1.23 pl_handler.c
*** src/pl/plpgsql/src/pl_handler.c	1 Aug 2004 17:32:22 -0000	1.23
--- src/pl/plpgsql/src/pl_handler.c	6 Feb 2005 23:15:38 -0000
***************
*** 47,53 ****
  
  extern DLLIMPORT bool check_function_bodies;
  
! static int	plpgsql_firstcall = 1;
  
  static void plpgsql_init_all(void);
  
--- 47,53 ----
  
  extern DLLIMPORT bool check_function_bodies;
  
! static bool	plpgsql_firstcall = true;
  
  static void plpgsql_init_all(void);
  
***************
*** 65,74 ****
  		return;
  
  	plpgsql_HashTableInit();
- 
  	RegisterXactCallback(plpgsql_xact_cb, NULL);
! 
! 	plpgsql_firstcall = 0;
  }
  
  /*
--- 65,72 ----
  		return;
  
  	plpgsql_HashTableInit();
  	RegisterXactCallback(plpgsql_xact_cb, NULL);
! 	plpgsql_firstcall = false;
  }
  
  /*
***************
*** 78,91 ****
  plpgsql_init_all(void)
  {
  	/* Execute any postmaster-startup safe initialization */
! 	if (plpgsql_firstcall)
! 		plpgsql_init();
  
  	/*
  	 * Any other initialization that must be done each time a new backend
  	 * starts -- currently none
  	 */
- 
  }
  
  /* ----------
--- 76,87 ----
  plpgsql_init_all(void)
  {
  	/* Execute any postmaster-startup safe initialization */
! 	plpgsql_init();
  
  	/*
  	 * Any other initialization that must be done each time a new backend
  	 * starts -- currently none
  	 */
  }
  
  /* ----------
Index: src/pl/plpgsql/src/plpgsql.h
===================================================================
RCS file: /var/lib/cvs/pgsql/src/pl/plpgsql/src/plpgsql.h,v
retrieving revision 1.56
diff -c -r1.56 plpgsql.h
*** src/pl/plpgsql/src/plpgsql.h	16 Sep 2004 16:58:44 -0000	1.56
--- src/pl/plpgsql/src/plpgsql.h	6 Feb 2005 23:15:38 -0000
***************
*** 50,56 ****
   **********************************************************************/
  
  /* ----------
!  * Compilers namestack item types
   * ----------
   */
  enum
--- 50,56 ----
   **********************************************************************/
  
  /* ----------
!  * Compiler's namestack item types
   * ----------
   */
  enum
***************
*** 147,153 ****
  typedef struct
  {								/* Dynamic string control structure */
  	int			alloc;
! 	int			used;
  	char	   *value;
  } PLpgSQL_dstring;
  
--- 147,153 ----
  typedef struct
  {								/* Dynamic string control structure */
  	int			alloc;
! 	int			used;			/* Including NUL terminator */
  	char	   *value;
  } PLpgSQL_dstring;
  
***************
*** 298,303 ****
--- 298,304 ----
  } PLpgSQL_nsitem;
  
  
+ /* XXX: consider adapting this to use List */
  typedef struct PLpgSQL_ns
  {								/* Compiler namestack level		*/
  	int			items_alloc;
***************
*** 314,327 ****
  } PLpgSQL_stmt;
  
  
- typedef struct
- {								/* List of execution nodes		*/
- 	int			stmts_alloc;	/* XXX this oughta just be a List ... */
- 	int			stmts_used;
- 	PLpgSQL_stmt **stmts;
- } PLpgSQL_stmts;
- 
- 
  typedef struct PLpgSQL_condition
  {								/* One EXCEPTION condition name */
  	int			sqlerrstate;	/* SQLSTATE code */
--- 315,320 ----
***************
*** 333,358 ****
  {								/* One EXCEPTION ... WHEN clause */
  	int			lineno;
  	PLpgSQL_condition *conditions;
! 	PLpgSQL_stmts *action;
  } PLpgSQL_exception;
  
  
  typedef struct
- {								/* List of WHEN clauses			*/
- 	int			exceptions_alloc;		/* XXX this oughta just be a List
- 										 * ... */
- 	int			exceptions_used;
- 	PLpgSQL_exception **exceptions;
- } PLpgSQL_exceptions;
- 
- 
- typedef struct
  {								/* Block of statements			*/
  	int			cmd_type;
  	int			lineno;
  	char	   *label;
! 	PLpgSQL_stmts *body;
! 	PLpgSQL_exceptions *exceptions;
  	int			n_initvars;
  	int		   *initvarnos;
  } PLpgSQL_stmt_block;
--- 326,342 ----
  {								/* One EXCEPTION ... WHEN clause */
  	int			lineno;
  	PLpgSQL_condition *conditions;
! 	List	   *action;			/* List of statements */
  } PLpgSQL_exception;
  
  
  typedef struct
  {								/* Block of statements			*/
  	int			cmd_type;
  	int			lineno;
  	char	   *label;
! 	List	   *body;			/* List of statements */
! 	List	   *exceptions;		/* List of WHEN clauses */
  	int			n_initvars;
  	int		   *initvarnos;
  } PLpgSQL_stmt_block;
***************
*** 375,381 ****
  
  typedef struct
  {								/* Get Diagnostics item		*/
! 	int			item;			/* id for diagnostic value desired */
  	int			target;			/* where to assign it */
  } PLpgSQL_diag_item;
  
--- 359,365 ----
  
  typedef struct
  {								/* Get Diagnostics item		*/
! 	int			kind;			/* id for diagnostic value desired */
  	int			target;			/* where to assign it */
  } PLpgSQL_diag_item;
  
***************
*** 383,390 ****
  {								/* Get Diagnostics statement		*/
  	int			cmd_type;
  	int			lineno;
! 	int			ndtitems;
! 	PLpgSQL_diag_item *dtitems;
  } PLpgSQL_stmt_getdiag;
  
  
--- 367,373 ----
  {								/* Get Diagnostics statement		*/
  	int			cmd_type;
  	int			lineno;
! 	List	   *diag_items;		/* List of PLpgSQL_diag_item */
  } PLpgSQL_stmt_getdiag;
  
  
***************
*** 393,400 ****
  	int			cmd_type;
  	int			lineno;
  	PLpgSQL_expr *cond;
! 	PLpgSQL_stmts *true_body;
! 	PLpgSQL_stmts *false_body;
  } PLpgSQL_stmt_if;
  
  
--- 376,383 ----
  	int			cmd_type;
  	int			lineno;
  	PLpgSQL_expr *cond;
! 	List	   *true_body;		/* List of statements */
! 	List	   *false_body;		/* List of statements */
  } PLpgSQL_stmt_if;
  
  
***************
*** 403,409 ****
  	int			cmd_type;
  	int			lineno;
  	char	   *label;
! 	PLpgSQL_stmts *body;
  } PLpgSQL_stmt_loop;
  
  
--- 386,392 ----
  	int			cmd_type;
  	int			lineno;
  	char	   *label;
! 	List	   *body;			/* List of statements */
  } PLpgSQL_stmt_loop;
  
  
***************
*** 413,419 ****
  	int			lineno;
  	char	   *label;
  	PLpgSQL_expr *cond;
! 	PLpgSQL_stmts *body;
  } PLpgSQL_stmt_while;
  
  
--- 396,402 ----
  	int			lineno;
  	char	   *label;
  	PLpgSQL_expr *cond;
! 	List	   *body;			/* List of statements */
  } PLpgSQL_stmt_while;
  
  
***************
*** 426,432 ****
  	PLpgSQL_expr *lower;
  	PLpgSQL_expr *upper;
  	int			reverse;
! 	PLpgSQL_stmts *body;
  } PLpgSQL_stmt_fori;
  
  
--- 409,415 ----
  	PLpgSQL_expr *lower;
  	PLpgSQL_expr *upper;
  	int			reverse;
! 	List	   *body;			/* List of statements */
  } PLpgSQL_stmt_fori;
  
  
***************
*** 438,444 ****
  	PLpgSQL_rec *rec;
  	PLpgSQL_row *row;
  	PLpgSQL_expr *query;
! 	PLpgSQL_stmts *body;
  } PLpgSQL_stmt_fors;
  
  
--- 421,427 ----
  	PLpgSQL_rec *rec;
  	PLpgSQL_row *row;
  	PLpgSQL_expr *query;
! 	List	   *body;			/* List of statements */
  } PLpgSQL_stmt_fors;
  
  
***************
*** 450,456 ****
  	PLpgSQL_rec *rec;
  	PLpgSQL_row *row;
  	PLpgSQL_expr *query;
! 	PLpgSQL_stmts *body;
  } PLpgSQL_stmt_dynfors;
  
  
--- 433,439 ----
  	PLpgSQL_rec *rec;
  	PLpgSQL_row *row;
  	PLpgSQL_expr *query;
! 	List	   *body;			/* List of statements */
  } PLpgSQL_stmt_dynfors;
  
  
***************
*** 527,534 ****
  	int			lineno;
  	int			elog_level;
  	char	   *message;
! 	int			nparams;
! 	int		   *params;
  } PLpgSQL_stmt_raise;
  
  
--- 510,516 ----
  	int			lineno;
  	int			elog_level;
  	char	   *message;
! 	List	   *params;
  } PLpgSQL_stmt_raise;
  
  
***************
*** 577,582 ****
--- 559,565 ----
  	CommandId	fn_cmin;
  	int			fn_functype;
  	PLpgSQL_func_hashkey *fn_hashkey;	/* back-link to hashtable key */
+ 	MemoryContext fn_cxt;
  
  	Oid			fn_rettype;
  	int			fn_rettyplen;
***************
*** 649,656 ****
   * Global variable declarations
   **********************************************************************/
  
! extern int	plpgsql_DumpExecTree;
! extern int	plpgsql_SpaceScanned;
  extern int	plpgsql_nDatums;
  extern PLpgSQL_datum **plpgsql_Datums;
  
--- 632,639 ----
   * Global variable declarations
   **********************************************************************/
  
! extern bool	plpgsql_DumpExecTree;
! extern bool	plpgsql_SpaceScanned;
  extern int	plpgsql_nDatums;
  extern PLpgSQL_datum **plpgsql_Datums;
  
***************
*** 684,690 ****
  extern int	plpgsql_parse_dblwordrowtype(char *word);
  extern PLpgSQL_type *plpgsql_parse_datatype(const char *string);
  extern PLpgSQL_type *plpgsql_build_datatype(Oid typeOid, int32 typmod);
! extern PLpgSQL_variable *plpgsql_build_variable(char *refname, int lineno,
  					   PLpgSQL_type *dtype,
  					   bool add2namespace);
  extern PLpgSQL_condition *plpgsql_parse_err_condition(char *condname);
--- 667,673 ----
  extern int	plpgsql_parse_dblwordrowtype(char *word);
  extern PLpgSQL_type *plpgsql_parse_datatype(const char *string);
  extern PLpgSQL_type *plpgsql_build_datatype(Oid typeOid, int32 typmod);
! extern PLpgSQL_variable *plpgsql_build_variable(const char *refname, int lineno,
  					   PLpgSQL_type *dtype,
  					   bool add2namespace);
  extern PLpgSQL_condition *plpgsql_parse_err_condition(char *condname);
***************
*** 717,722 ****
--- 700,706 ----
  extern void plpgsql_dstring_init(PLpgSQL_dstring *ds);
  extern void plpgsql_dstring_free(PLpgSQL_dstring *ds);
  extern void plpgsql_dstring_append(PLpgSQL_dstring *ds, const char *str);
+ extern void plpgsql_dstring_append_char(PLpgSQL_dstring *ds, char c);
  extern char *plpgsql_dstring_get(PLpgSQL_dstring *ds);
  
  /* ----------
***************
*** 727,733 ****
  extern bool plpgsql_ns_setlocal(bool flag);
  extern void plpgsql_ns_push(char *label);
  extern void plpgsql_ns_pop(void);
! extern void plpgsql_ns_additem(int itemtype, int itemno, char *name);
  extern PLpgSQL_nsitem *plpgsql_ns_lookup(char *name, char *nsname);
  extern void plpgsql_ns_rename(char *oldname, char *newname);
  
--- 711,717 ----
  extern bool plpgsql_ns_setlocal(bool flag);
  extern void plpgsql_ns_push(char *label);
  extern void plpgsql_ns_pop(void);
! extern void plpgsql_ns_additem(int itemtype, int itemno, const char *name);
  extern PLpgSQL_nsitem *plpgsql_ns_lookup(char *name, char *nsname);
  extern void plpgsql_ns_rename(char *oldname, char *newname);
  
Index: src/pl/plpgsql/src/scan.l
===================================================================
RCS file: /var/lib/cvs/pgsql/src/pl/plpgsql/src/scan.l,v
retrieving revision 1.38
diff -c -r1.38 scan.l
*** src/pl/plpgsql/src/scan.l	17 Dec 2004 03:51:36 -0000	1.38
--- src/pl/plpgsql/src/scan.l	6 Feb 2005 23:15:38 -0000
***************
*** 54,60 ****
  static const char *scanstr;		/* original input string */
  
  static int	scanner_functype;
! static int	scanner_typereported;
  static int	pushback_token;
  static bool have_pushback_token;
  static int	lookahead_token;	
--- 54,60 ----
  static const char *scanstr;		/* original input string */
  
  static int	scanner_functype;
! static bool	scanner_typereported;
  static int	pushback_token;
  static bool have_pushback_token;
  static int	lookahead_token;	
***************
*** 64,70 ****
  static char    *dolqstart;      /* current $foo$ quote start string */
  static int	dolqlen;			/* signal to plpgsql_get_string_value */
  
! int	plpgsql_SpaceScanned = 0;
  %}
  
  %option 8bit
--- 64,70 ----
  static char    *dolqstart;      /* current $foo$ quote start string */
  static int	dolqlen;			/* signal to plpgsql_get_string_value */
  
! bool plpgsql_SpaceScanned = false;
  %}
  
  %option 8bit
***************
*** 114,120 ****
       * ----------
       */
      BEGIN(INITIAL);
!     plpgsql_SpaceScanned = 0;
  
      /* ----------
       * On the first call to a new source report the
--- 114,120 ----
       * ----------
       */
      BEGIN(INITIAL);
!     plpgsql_SpaceScanned = false;
  
      /* ----------
       * On the first call to a new source report the
***************
*** 123,129 ****
       */
  	if (!scanner_typereported)
  	{
! 		scanner_typereported = 1;
  		return scanner_functype;
  	}
  
--- 123,129 ----
       */
  	if (!scanner_typereported)
  	{
! 		scanner_typereported = true;
  		return scanner_functype;
  	}
  
***************
*** 255,261 ****
       * Ignore whitespaces but remember this happened
       * ----------
       */
! {space}+		{ plpgsql_SpaceScanned = 1;		}
  
      /* ----------
       * Eat up comments
--- 255,261 ----
       * Ignore whitespaces but remember this happened
       * ----------
       */
! {space}+		{ plpgsql_SpaceScanned = true;		}
  
      /* ----------
       * Eat up comments
***************
*** 266,272 ****
  \/\*			{ start_lineno = plpgsql_scanner_lineno();
  			  BEGIN(IN_COMMENT);
  			}
! <IN_COMMENT>\*\/	{ BEGIN(INITIAL); plpgsql_SpaceScanned = 1; }
  <IN_COMMENT>\n		;
  <IN_COMMENT>.		;
  <IN_COMMENT><<EOF>>	{
--- 266,272 ----
  \/\*			{ start_lineno = plpgsql_scanner_lineno();
  			  BEGIN(IN_COMMENT);
  			}
! <IN_COMMENT>\*\/	{ BEGIN(INITIAL); plpgsql_SpaceScanned = true; }
  <IN_COMMENT>\n		;
  <IN_COMMENT>.		;
  <IN_COMMENT><<EOF>>	{
***************
*** 502,508 ****
  	scanstr = str;
  
      scanner_functype = functype;
!     scanner_typereported = 0;
  
  	have_pushback_token = false;
  	have_lookahead_token = false;
--- 502,508 ----
  	scanstr = str;
  
      scanner_functype = functype;
!     scanner_typereported = false;
  
  	have_pushback_token = false;
  	have_lookahead_token = false;
***************
*** 538,544 ****
  
  /*
   * Called after a T_STRING token is read to get the string literal's value
!  * as a malloc'd string.  (We make this a separate call because in many
   * scenarios there's no need to get the decoded value.)
   *
   * Note: we expect the literal to be the most recently lexed token.  This
--- 538,544 ----
  
  /*
   * Called after a T_STRING token is read to get the string literal's value
!  * as a palloc'd string.  (We make this a separate call because in many
   * scenarios there's no need to get the decoded value.)
   *
   * Note: we expect the literal to be the most recently lexed token.  This
***************
*** 557,570 ****
  		/* Token is a $foo$...$foo$ string */
  		len = yyleng - 2 * dolqlen;
  		Assert(len >= 0);
! 		result = (char *) malloc(len + 1);
  		memcpy(result, yytext + dolqlen, len);
  		result[len] = '\0';
  	}
  	else
  	{
  		/* Token is a '...' string */
! 		result = (char *) malloc(yyleng + 1);	/* more than enough room */
  		len = 0;
  		for (cp = yytext; *cp; cp++)
  		{
--- 557,570 ----
  		/* Token is a $foo$...$foo$ string */
  		len = yyleng - 2 * dolqlen;
  		Assert(len >= 0);
! 		result = (char *) palloc(len + 1);
  		memcpy(result, yytext + dolqlen, len);
  		result[len] = '\0';
  	}
  	else
  	{
  		/* Token is a '...' string */
! 		result = (char *) palloc(yyleng + 1);	/* more than enough room */
  		len = 0;
  		for (cp = yytext; *cp; cp++)
  		{
Index: src/test/regress/expected/plpgsql.out
===================================================================
RCS file: /var/lib/cvs/pgsql/src/test/regress/expected/plpgsql.out,v
retrieving revision 1.25
diff -c -r1.25 plpgsql.out
*** src/test/regress/expected/plpgsql.out	19 Jan 2005 04:32:10 -0000	1.25
--- src/test/regress/expected/plpgsql.out	7 Feb 2005 05:52:23 -0000
***************
*** 2173,2175 ****
--- 2173,2196 ----
   f               | t
  (1 row)
  
+ --
+ -- tests for "raise" processing
+ --
+ create function raise_test1(int) returns int as $$
+ begin
+     raise notice 'This message has too many parameters!', $1;
+     return $1;
+ end;
+ $$ language 'plpgsql';
+ select raise_test1(5);
+ ERROR:  too many parameters specified for RAISE
+ CONTEXT:  PL/pgSQL function "raise_test1" line 2 at raise
+ create function raise_test2(int) returns int as $$
+ begin
+     raise notice 'This message has too few parameters: %, %, %', $1, $1;
+     return $1;
+ end;
+ $$ language 'plpgsql';
+ select raise_test2(10);
+ ERROR:  too few parameters specified for RAISE
+ CONTEXT:  PL/pgSQL function "raise_test2" line 2 at raise
Index: src/test/regress/sql/plpgsql.sql
===================================================================
RCS file: /var/lib/cvs/pgsql/src/test/regress/sql/plpgsql.sql,v
retrieving revision 1.20
diff -c -r1.20 plpgsql.sql
*** src/test/regress/sql/plpgsql.sql	19 Jan 2005 04:32:40 -0000	1.20
--- src/test/regress/sql/plpgsql.sql	6 Feb 2005 23:15:38 -0000
***************
*** 1863,1865 ****
--- 1863,1886 ----
  
  select refcursor_test2(20000) as "Should be false",
         refcursor_test2(20) as "Should be true";
+ 
+ --
+ -- tests for "raise" processing
+ --
+ create function raise_test1(int) returns int as $$
+ begin
+     raise notice 'This message has too many parameters!', $1;
+     return $1;
+ end;
+ $$ language 'plpgsql';
+ 
+ select raise_test1(5);
+ 
+ create function raise_test2(int) returns int as $$
+ begin
+     raise notice 'This message has too few parameters: %, %, %', $1, $1;
+     return $1;
+ end;
+ $$ language 'plpgsql';
+ 
+ select raise_test2(10);
